Package: multimediate
Title: Causal Mediation Analysis in Presence of Multiple Mediators
        Uncausally Related
Version: 0.1.6
Authors@R: 
    c(person(given = "Allan",
             family = "Jerolon",
             role = c("aut")),
      person(given = "Arce",
             family = "Domingo-Relloso",
             role = c("aut")),       
      person(given = "Samara",
             family = "Kiihl",
             role = c("cre", "aut"),
             email = "samarak@unicamp.br"),
      person(given = "Maria",
             family = "Tellez-Plaza",
             role = c("aut")))       
Description: Estimates key quantities in causal mediation analysis - including 
    average causal mediation effects (indirect effects), average direct 
    effects, total effects, and proportions mediated - in the presence of 
    multiple uncausally related mediators. Methods are described by 
    Jerolon et al., (2021) <doi:10.1515/ijb-2019-0088> and extended to 
    accommodate survival outcomes as described by Domingo-Relloso et al., 
    (2024) <doi:10.1101/2024.02.16.24302923>.
License: GPL-3
Encoding: UTF-8
LazyData: true
URL: https://samarafk.github.io/multimediate/
Imports: rmutil, MASS, mvtnorm, stats, graphics, timereg
Suggests: rmarkdown
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-05-20 15:46:34 UTC; samara
Author: Allan Jerolon [aut],
  Arce Domingo-Relloso [aut],
  Samara Kiihl [cre, aut],
  Maria Tellez-Plaza [aut]
Maintainer: Samara Kiihl <samarak@unicamp.br>
Repository: CRAN
Date/Publication: 2026-05-21 07:20:21 UTC
Built: R 4.5.2; ; 2026-05-22 05:43:47 UTC; unix

Package: multimediate
Title: Causal Mediation Analysis in Presence of Multiple Mediators
        Uncausally Related
Version: 0.1.4
Authors@R: 
    c(person(given = "Allan",
             family = "Jerolon",
             role = c("aut")),
      person(given = "Arce",
             family = "Domingo-Relloso",
             role = c("aut")),       
      person(given = "Samara",
             family = "Kiihl",
             role = c("cre", "aut"),
             email = "samarak@unicamp.br"),
      person(given = "Maria",
             family = "Tellez-Plaza",
             role = c("aut")))       
Description: Estimates key quantities in causal mediation analysis - including 
    average causal mediation effects (indirect effects), average direct 
    effects, total effects, and proportions mediated - in the presence of 
    multiple uncausally related mediators. Methods are described by 
    Jérolon et al., (2021) <doi:10.1515/ijb-2019-0088> and extended to 
    accommodate survival outcomes as described by Domingo-Relloso et al., 
    (2024) <doi:10.1101/2024.02.16.24302923>.
License: GPL-3
Encoding: UTF-8
LazyData: true
URL: https://samarafk.github.io/multimediate/
Imports: rmutil, MASS, mvtnorm, stats, graphics, timereg
Suggests: knitr, rmarkdown
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-07-09 18:59:16 UTC; samara
Author: Allan Jerolon [aut],
  Arce Domingo-Relloso [aut],
  Samara Kiihl [cre, aut],
  Maria Tellez-Plaza [aut]
Maintainer: Samara Kiihl <samarak@unicamp.br>
Repository: CRAN
Date/Publication: 2025-07-14 17:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 08:59:56 UTC; unix

# multimediate

This package is based on the work presented in A. Jérolon et al., [Causal mediation analysis in presence of multiple mediators uncausally related](https://doi.org/10.1515/ijb-2019-0088).

The work allowing multiple mediation analyzes with a survival outcome was 
largely developed with Arce Domingo-Relloso. 
This work is presented in Domingo-Relloso et al., [Causal mediation for uncausally related mediators in the context of survival analysis](https://doi.org/10.1101/2024.02.16.24302923). 


## Installation

You can install the package from the repository (https://github.com/samarafk/multimediate):

```r
library(devtools)
install_github("samarafk/multimediate") 
```

Or you can install the released version of `multimediate` from CRAN with:

```r
install.packages("multimediate")
```

## Examples

Vignettes and examples of usage can be found in https://samarafk.github.io/multimediate/.

# multimediate

This package is based on the work presented in A. Jérolon et al., [Causal mediation analysis in presence of multiple mediators uncausally related](https://doi.org/10.1515/ijb-2019-0088).

The work allowing multiple mediation analyzes with a survival outcome was 
largely developed with Arce Domingo-Relloso. 
This work is presented in Domingo-Relloso et al., [Causal mediation for uncausally related mediators in the context of survival analysis](https://doi.org/10.1101/2024.02.16.24302923). 


## Installation

You can install the package from the repository (https://github.com/samarafk/multimediate):

```r
library(devtools)
install_github("samarafk/multimediate") 
```

Or you can install the released version from [CRAN](https://cran.r-project.org) with:

```r
install.packages("multimediate")
```

## Examples

Vignettes and examples of usage can be found at https://samarafk.github.io/multimediate/.

#' plot.mm
#'
#' \code{plot.mm} is used to display the results of the mediation analyzes done with \code{multimediate}.
#'
#'
#' @param x element of the class "mm".
#' @param treatment a character string indicating the baseline treatment value of the estimated causal mediation effect and direct effect to plot. Can be either "control", "treated", "average" or "three". If "NULL"(default), three sets of estimates are plotted.
#' @param logit a character string indicating, when the outcome is binary, the scale of the average causal effects. "effects" for average causal effects, " OR" average causal effects on OR scale, "logOR" average causal effects on logOR scale.
#' @param labels a vector of character strings indicating the labels for estimated effects. The default labels wiil be used if NULL.
#' @param effect.type a vector indicating which quantities of interest to plot. Default is to plot all three quantities (indirects, direct and total effects).
#' @param xlim range of the horizontal axis.
#' @param ylim range of the vertical axis.
#' @param xlab label of the horizontal axis.
#' @param ylab label of the vertical axis.
#' @param main main title.
#' @param is.legend a logical value indicating the presence of the legend on top right. If the legend obscures some results, is.legend can be switched to "FALSE" or the x-axis can be changed manually with the parameters xlim.
#' @param lwd width of the horizontal bars for confidence intervals.
#' @param cex size of the dots for point estimates.
#' @param col color of the dots and horizontal bars for the estimates.
#' @param ... additional parameters passed to 'plot'.
#'
#'
#' @return plot summarizing the causal analysis
#'
#' @export
#'
#' @import graphics
#'
#' @keywords internal


plot.mm = function(x, treatment = NULL,logit="logOR", labels = NULL, effect.type = c("indirect","direct", "total"), xlim = NULL, ylim = NULL, xlab = "", ylab = "", main = "Estimates and confidence intervals",is.legend=TRUE, lwd = 1.5, cex = 0.85, col = "black",...){

  effect.type <- match.arg(effect.type, several.ok = TRUE)
  IND <- "indirect" %in% effect.type
  DIR <- "direct" %in% effect.type
  TOT <- "total" %in% effect.type
  if (is.null(treatment)) {
      treatment <- c(0, 1, 2)
    }
  else {
    treatment <- switch(treatment, control = 0, treated = 1, average = 2,
                        three = c(0, 1, 2))
  }
  if (logit=="logOR"){
    param <- extract.plot.process(x,logit="logOR")
    main=paste(main, "on log OR scale")
    vline <- 0
  }
  else if (logit=="OR"){
    param <- extract.plot.process(x,logit="OR")
    main=paste(main, "on OR scale")
    vline <- 1
  }
  else{
    param <- extract.plot.process(x,logit="effects")
    vline <- 0
  }
  NM=length(x$mediator)
  y.axis <- (IND*(NM+1) + DIR + TOT):1
  if (is.null(xlim)) {
    plusx=c(-.05,0.05)
    if (length(treatment) > 1) {
      xlim <- range(param$range.1, param$range.0) + plusx
    }
    else if (treatment == 1) {
      xlim <- param$range.1 + plusx
    }
    else if (treatment == 0){
      xlim <- param$range.0 + plusx
    }
    else{
      xlim <- param$range.avg + plusx
    }
  }
  if (is.null(ylim)) {
    ylim <- c(min(y.axis) - 0.5, max(y.axis) + 0.5)
  }
  plot(rep(0, IND*(NM+1) + DIR + TOT), y.axis, type = "n", xlab = xlab,
       ylab = ylab, yaxt = "n", xlim = xlim, ylim = ylim, main = main,
       ...)
  if (length(treatment) == 1) {
    adj <- c(0,0,0)
  }
  else  {
    adj <- c(-0.2,0,0.2)
  }
  if (1 %in% treatment) {

    if (IND && DIR) {


        points(param$coef.vec.1.NM, y.axis[1:NM] + adj[1], type = "p",
               pch = 19, cex = cex, col = col)
        segments(param$lower.vec.1.NM, y.axis[1:NM] + adj[1], param$upper.vec.1.NM,
                 y.axis[1:NM] + adj[1], lwd = lwd, col = col)

      points(param$coef.vec.1, y.axis[(NM+1):(NM+2)] + adj[1], type = "p",
             pch = 19, cex = cex, col = col)
      segments(param$lower.vec.1, y.axis[(NM+1):(NM+2)] + adj[1], param$upper.vec.1,
               y.axis[(NM+1):(NM+2)] + adj[1], lwd = lwd, col = col)


    }
    if (IND && !DIR) {

        points(param$coef.vec.1.NM, y.axis[1:NM] + adj[1], type = "p",
               pch = 19, cex = cex, col = col)
        segments(param$lower.vec.1.NM, y.axis[1:NM] + adj[1], param$upper.vec.1.NM,
                 y.axis[1:NM] + adj[1], lwd = lwd, col = col)

      points(param$coef.vec.1[1], y.axis[NM+1] + adj[1], type = "p",
             pch = 19, cex = cex, col = col)
      segments(param$lower.vec.1[1], y.axis[NM+1] + adj[1], param$upper.vec.1[1],
               y.axis[NM+1] + adj[1], lwd = lwd, col = col)
    }
    if (!IND && DIR) {
      points(param$coef.vec.1[2], y.axis[1] + adj[1], type = "p",
             pch = 19, cex = cex, col = col)
      segments(param$lower.vec.1[2], y.axis[1] + adj[1], param$upper.vec.1[2],
               y.axis[1] + adj[1], lwd = lwd, col = col)
    }
  }
  if (0 %in% treatment) {
    if (IND && DIR) {

        points(param$coef.vec.0.NM, y.axis[1:NM] + adj[3], type = "p",
               pch = 1, cex = cex, col = col)
        segments(param$lower.vec.0.NM, y.axis[1:NM] + adj[3], param$upper.vec.0.NM,
                 y.axis[1:NM] + adj[3], lwd = lwd, lty = 3, col = col)

      points(param$coef.vec.0, y.axis[(NM+1):(NM+2)] + adj[3], type = "p",
             pch = 1, cex = cex, col = col)
      segments(param$lower.vec.0, y.axis[(NM+1):(NM+2)] + adj[3], param$upper.vec.0,
               y.axis[(NM+1):(NM+2)] + adj[3], lwd = lwd, lty = 3, col = col)
    }
    if (IND && !DIR) {

        points(param$coef.vec.0.NM, y.axis[1:NM] + adj[3], type = "p",
               pch = 1, cex = cex, col = col)
        segments(param$lower.vec.0.NM, y.axis[1:NM] + adj[3], param$upper.vec.0.NM,
                 y.axis[1:NM] + adj[3], lwd = lwd, lty = 3, col = col)

      points(param$coef.vec.0[1], y.axis[NM+1] + adj[3], type = "p",
             pch = 1, cex = cex, col = col)
      segments(param$lower.vec.0[1], y.axis[NM+1] + adj[3], param$upper.vec.0[1],
               y.axis[NM+1] + adj[3], lwd = lwd, lty = 3, col = col)
    }
    if (!IND && DIR) {
      points(param$coef.vec.0[2], y.axis[1] + adj[3], type = "p",
             pch = 1, cex = cex, col = col)
      segments(param$lower.vec.0[2], y.axis[1] + adj[3], param$upper.vec.0[2],
               y.axis[1] + adj[3], lwd = lwd, lty = 3, col = col)
    }
  }
  if (2 %in% treatment) {
    if (IND && DIR) {

        points(param$coef.vec.avg.NM, y.axis[1:NM] + adj[2], type = "p",
               pch = 10, cex = cex, col = col)
        segments(param$lower.vec.avg.NM, y.axis[1:NM] + adj[2], param$upper.vec.avg.NM,
                 y.axis[1:NM] + adj[2], lwd = lwd, lty = 5, col = col)

      points(param$coef.vec.avg, y.axis[(NM+1):(NM+2)] + adj[2], type = "p",
             pch = 10, cex = cex, col = col)
      segments(param$lower.vec.avg, y.axis[(NM+1):(NM+2)] + adj[2], param$upper.vec.avg,
               y.axis[(NM+1):(NM+2)] + adj[2], lwd = lwd, lty = 5, col = col)
    }
    if (IND && !DIR) {

        points(param$coef.vec.avg.NM, y.axis[1:NM] + adj[2], type = "p",
               pch = 10, cex = cex, col = col)
        segments(param$lower.vec.avg.NM, y.axis[1:NM] + adj[2], param$upper.vec.avg.NM,
                 y.axis[1:NM] + adj[2], lwd = lwd, lty = 5, col = col)

      points(param$coef.vec.avg[1], y.axis[NM+1] + adj[2], type = "p",
             pch = 10, cex = cex, col = col)
      segments(param$lower.vec.avg[1], y.axis[NM+1] + adj[2], param$upper.vec.avg[1],
               y.axis[NM+1] + adj[2], lwd = lwd, lty = 5, col = col)
    }
    if (!IND && DIR) {
      points(param$coef.vec.avg[2], y.axis[1] + adj[2], type = "p",
             pch = 10, cex = cex, col = col)
      segments(param$lower.vec.avg[2], y.axis[1] + adj[2], param$upper.vec.avg[2],
               y.axis[1] + adj[2], lwd = lwd, lty = 5, col = col)
    }
  }
  if (TOT) {
    points(param$tau.vec[1], 1, type = "p", pch = 19, cex = cex,
           col = col)
    segments(param$tau.vec[2], 1, param$tau.vec[3], 1, lwd = lwd,
             col = col)
  }
  if (is.null(labels)) {
    labels <- c(paste("ACME\n",x$mediator,sep=""),"ACME\nJoint", "ADE", "Total\nEffect")[c(rep(IND,NM+1), DIR,TOT)]
  }
  axis(2, at = y.axis, labels = labels, las = 1, tick = TRUE,
       ...)

  abline(v = vline, lty = 2)
  if (is.legend){
    legend("topright",legend=c("control value","average","treated value"),pch=c(1,10,19),lty=c(3,5,1),title="Effects calculated with")

  }
  }

#'
#'
#'@import stats
#'
#'
#'

CorCond = function(e,lmodel.m){
  NM=length(lmodel.m)
  k=1

  out=list()
  while(k < NM){
    for(l in (k+1):NM){
      a=paste("cor",names(lmodel.m[[k]]$model)[1],names(lmodel.m[[l]]$model)[1],sep=".")
      out[[a]]=CorCond2(e,lmodel=list(lmodel.m[[k]],lmodel.m[[l]]))
    }
    k=k+1
  }
  Variance=rep(1,NM)
  for (z in 1:NM){
    if (inherits(lmodel.m[[z]],"lm") & !inherits(lmodel.m[[z]],"glm")){
      Variance[z]=var(lmodel.m[[z]]$residuals)
    }
  }
  sigmaestim=diag(Variance)
  correstim=diag(1,NM)
  i=1
  l=1
  vcor=c()
  vcov=c()
  while (i <NM){
    j=i+1
    for(k in j:NM){
      sigmaestim[i,k]=sigmaestim[k,i]=weighted.mean(out[[l]]$Covariance.estim,out[[l]]$Proportion,na.rm = TRUE)
      vcov=c(vcov,weighted.mean(out[[l]]$Covariance.estim,out[[l]]$Proportion,na.rm = TRUE))
      correstim[i,k]=correstim[k,i]=weighted.mean(out[[l]]$Correlation.estim,out[[l]]$Proportion,na.rm = TRUE)
      vcor=c(vcor,weighted.mean(out[[l]]$Correlation.estim,out[[l]]$Proportion,na.rm = TRUE))
      l=l+1
    }
    i=i+1
  }
  out[["sigmaestim"]]=sigmaestim
  out[["vcov"]]=vcov
  out[["correstim"]]=correstim
  out[["vcor"]]=vcor
  return(out)
}


#' @importFrom rmutil int

CorCond2 = function(e,lmodel){

  is.Lm.Mi=inherits(lmodel[[1]],"lm") & !inherits(lmodel[[1]],"glm")
  is.Lm.Mj=inherits(lmodel[[2]],"lm") & !inherits(lmodel[[2]],"glm")


  if(is.Lm.Mi & is.Lm.Mj){
    Estim=data.frame(NA)
    Estim$Proportion=1
    Estim$Covariance.estim=cov(lmodel[[1]]$residuals,lmodel[[2]]$residuals)
    Estim$Correlation.estim=cor(lmodel[[1]]$residuals,lmodel[[2]]$residuals)
  }

  else{
    Mi=names(lmodel[[1]]$model)[1]
    Mj=names(lmodel[[2]]$model)[1]
    data=cbind(lmodel[[1]]$model,lmodel[[2]]$model)[,unique(c(names(lmodel[[1]]$model),names(lmodel[[2]]$model)))]
    datav=data[,-c(which(names(data)==Mi),which(names(data)==Mj)),drop = FALSE]
    value=unique(datav)

    if(is.null(dim(value))){
      value=data.frame(t(t(value)))
      colnames(value)=names(lmodel[[1]]$model)[2]
      datav=data.frame(t(t(datav)))
      colnames(datav)=names(lmodel[[1]]$model)[2]
    }
    else{
      for (y in 1:dim(value)[2]){

        if (is.factor(value[,y])){
          test=length(grep(pattern = "[a-z][1-9][a-z]", value[,y], value = TRUE, fixed=FALSE))
          if (test==0){
            value[,y]=as.numeric(as.character(value[,y]))
          }

        }
      }
    }

    is.Polr.Mi=inherits(lmodel[[1]],"polr")
    is.Polr.Mj=inherits(lmodel[[2]],"polr")
    is.Glm.Mi=inherits(lmodel[[1]],"glm")
    is.Glm.Mj=inherits(lmodel[[2]],"glm")

    if(is.Polr.Mi & is.Polr.Mj){
      p=sort(as.numeric(as.character(unique(data[,Mi]))))
      interceptp=as.vector(c(-Inf,lmodel[[1]]$zeta,Inf))
      coefp=as.vector(lmodel[[1]]$coefficients)
      q=sort(as.numeric(as.character(unique(data[,Mj]))))
      interceptq=as.vector(c(-Inf,lmodel[[2]]$zeta,Inf))
      coefq=as.vector(lmodel[[2]]$coefficients)
    }

    if(is.Glm.Mi & is.Glm.Mj){
      p=c(0,1)
      interceptp=c(-Inf,-summary(lmodel[[1]])$coefficients[1,1],Inf)
      coefp=as.vector(summary(lmodel[[1]])$coefficients[-1,1])
      q=c(0,1)
      interceptq=c(-Inf,-summary(lmodel[[2]])$coefficients[1,1],Inf)
      coefq=as.vector(summary(lmodel[[2]])$coefficients[-1,1])
    }

    else if(is.Polr.Mi & is.Glm.Mj){
      p=sort(as.numeric(as.character(unique(data[,Mi]))))
      interceptp=as.vector(c(-Inf,lmodel[[1]]$zeta,Inf))
      coefp=as.vector(lmodel[[1]]$coefficients)
      q=c(0,1)
      interceptq=c(-Inf,-summary(lmodel[[2]])$coefficients[1,1],Inf)
      coefq=as.vector(summary(lmodel[[2]])$coefficients[-1,1])
    }

    else if(is.Glm.Mi & is.Polr.Mj){
      p=c(0,1)
      interceptp=c(-Inf,-summary(lmodel[[1]])$coefficients[1,1],Inf)
      coefp=as.vector(summary(lmodel[[1]])$coefficients[-1,1])
      q=sort(as.numeric(as.character(unique(data[,Mj]))))
      interceptq=as.vector(c(-Inf,lmodel[[2]]$zeta,Inf))
      coefq=as.vector(lmodel[[2]]$coefficients)
    }

    else if(is.Polr.Mi & is.Lm.Mj){
      p=sort(as.numeric(as.character(unique(data[,Mi]))))
      interceptp=as.vector(c(-Inf,lmodel[[1]]$zeta,Inf))
      coefp=as.vector(lmodel[[1]]$coefficients)
    }

    else if(is.Lm.Mi & is.Polr.Mj){
      p=sort(as.numeric(as.character(unique(data[,Mj]))))
      interceptp=as.vector(c(-Inf,lmodel[[2]]$zeta,Inf))
      coefp=as.vector(lmodel[[2]]$coefficients)
    }

    else if(is.Glm.Mi & is.Lm.Mj){
      p=c(0,1)
      interceptp=c(-Inf,-summary(lmodel[[1]])$coefficients[1,1],Inf)
      coefp=as.vector(summary(lmodel[[1]])$coefficients[-1,1])
    }

    else if (is.Lm.Mi & is.Glm.Mj){
      p=c(0,1)
      interceptp=c(-Inf,-summary(lmodel[[2]])$coefficients[1,1],Inf)
      coefp=as.vector(summary(lmodel[[2]])$coefficients[-1,1])
    }

    Value=NULL
    Proportion=NULL
    Covariance.estim=NULL
    Correlation.estim=NULL
    for (i in 1:dim(value)[1]){
      # Get the current row of values to match
      current_values = value[i, , drop = FALSE]

      # Create a logical vector for matching
      matches = rep(TRUE, nrow(data))

      # Check each covariate
      for (col_name in colnames(datav)) {
        if (is.numeric(datav[[col_name]]) || is.numeric(current_values[[col_name]])) {
          # For numeric variables, use tolerance-based comparison
          # Convert to numeric if needed
          data_col = as.numeric(as.character(data[[col_name]]))
          target_val = as.numeric(as.character(current_values[[col_name]]))

          # Use tolerance for comparison (adjust tol as needed)
          tol = sqrt(.Machine$double.eps)
          matches = matches & (abs(data_col - target_val) <= tol)
        } else {
          # For factor/character variables, use exact match
          matches = matches & (as.character(data[[col_name]]) == as.character(current_values[[col_name]]))
        }
      }

      datai = data[matches, , drop = FALSE]

      # skip if not enough observations
      if (nrow(datai) < 2) next

      valueMi=c(1,as.numeric(as.character(value[i,names(value) %in% names(lmodel[[1]]$model)])))
      valueMj=c(1,as.numeric(as.character(value[i,names(value) %in% names(lmodel[[2]]$model)])))

      covMiMj=cov(as.numeric(as.character(datai[,Mi])),as.numeric(as.character(datai[,Mj])))

      # skip if covariance is NA or infinite
      if (is.na(covMiMj) || !is.finite(covMiMj)) next

      if( (is.Polr.Mi & is.Polr.Mj) | (is.Glm.Mi & is.Polr.Mj) | (is.Polr.Mi & is.Glm.Mj) | (is.Glm.Mi & is.Glm.Mj) ){
        bornep=borneq=NULL
        for (o in 1:length(interceptp)){
          bornep=c(bornep,sum(c(interceptp[o],-coefp)*valueMi))
        }
        for (o in 1:length(interceptq)){
          borneq=c(borneq,sum(c(interceptq[o],-coefq)*valueMj))
        }

        pMit=pnorm(bornep)
        pMit=pMit[2:length(pMit)]-pMit[1:(length(pMit)-1)]
        pMi=sum(p*pMit)
        pMjt=pnorm(borneq)
        pMjt=pMjt[2:length(pMjt)]-pMjt[1:(length(pMjt)-1)]
        pMj=sum(q*pMjt)
        cor=DichotomiePD(fPD,e,covMiMj,pMi,bornep,p,pMj,borneq,q)
      }

      if ((is.Polr.Mi & is.Lm.Mj) | (is.Lm.Mi & is.Polr.Mj) | (is.Glm.Mi & is.Lm.Mj) | (is.Lm.Mi & is.Glm.Mj))  {
        if(is.Polr.Mi & is.Lm.Mj){
          valueM=valueMi
        }

        else if(is.Lm.Mi & is.Polr.Mj){
          valueM=valueMj
        }

        else if(is.Glm.Mi & is.Lm.Mj){
          valueM=valueMi
        }

        else if (is.Lm.Mi & is.Glm.Mj){
          valueM=valueMj
        }
        bornep=NULL
        for (o in 1:length(interceptp)){
          bornep=c(bornep,sum(c(interceptp[o],-coefp)*valueM))
        }
        g=function(x){
          return(x*dnorm(x,0,1))
        }
        smp=NULL
        for (e in 1:length(p)){
          smp=c(smp,p[e]*int(g, a=bornep[e], b=bornep[e+1]))
        }
        cor=covMiMj/sum(smp)
      }


      Valuetf1=paste(value[i,])
      Valuetf2=NULL
      for (j in 1:length(Valuetf1)){
        Valuetf2=paste(Valuetf2,Valuetf1[j],sep="")
      }
      Value=c(Value,Valuetf2)
      Proportion=c(Proportion,dim(datai)[1]/dim(data)[1])
      Covariance.estim=c(Covariance.estim,round(covMiMj,4))
      Correlation.estim=c(Correlation.estim,round(cor,4))
    }

    Estim=data.frame(Value,Proportion,Covariance.estim,Correlation.estim)

  }

  return(Estim)
}

DichotomiePD = function(fPD,e,covMiMj,pMi,bornep,p,pMj,borneq,q){
  u=-1
  v=1
  K=0
  while (abs(u-v)>=e/2) {
    m=(u+v)/2
    fu=fPD(rho=u,covMiMj,pMi,bornep,p,pMj,borneq,q)
    fm=fPD(rho=m,covMiMj,pMi,bornep,p,pMj,borneq,q)
    if (fu*fm<0)
    {v=m}
    else
    {u=m}
    K=K+1
  }
  return(u)
}

#' @importFrom mvtnorm pmvnorm
fPD = function(rho,covMiMj,pMi,bornep,p,pMj,borneq,q){
  Sigma1=matrix(c(1,rho,rho,1),2,2)
  pmvn=NULL
  for (i in 1:length(p)){
    for(j in 1:length(q)){
      pmvn=c(pmvn,p[i]*q[j]*pmvnorm(lower=c(bornep[i],borneq[j]),upper=c(bornep[i+1],borneq[j+1]),sigma=Sigma1))
    }
  }
  out=covMiMj-sum(pmvn)+pMi*pMj
  return(out)
}

getvarnames = function(formula, data = NULL)
{
  if (is.character(formula))
    return(list(varnames=formula, xvar=formula, yvar=NULL))
  if (is.null(formula)) return(list(varnames=NULL, xvar=NULL, yvar=NULL))

  formula <- formula(formula)
  lyv <- NULL
  lxv <- lvnm <- all.vars(formula[1:2])
  if (length(formula)==3) {
    lyv <- lxv
    lxv <- all.vars(formula[-2])
    if ("." %in% lxv) {
      if (length(data)==0)
        stop("!getvarnames! '.' in formula and no 'data'")
      lform <- formula(terms(formula, data=data))
      lxv <- all.vars(lform[-2])
    }
    lvnm <- c(lxv, lvnm)
  }
  return(list(varnames=lvnm, xvar=lxv, yvar=lyv))
}

extract.plot.process = function(model,logit="effects"){

  if (logit=="OR"){
    coef.vec.1 <- c(model$ORd1, model$ORz1)
    lower.vec.1 <- c(model$ORd1.ci[1], model$ORz1.ci[1])
    upper.vec.1 <- c(model$ORd1.ci[2], model$ORz1.ci[2])
    coef.vec.1.NM <- model$ORd1.NM
    lower.vec.1.NM <- model$ORd1.ci.NM[,1]
    upper.vec.1.NM <- model$ORd1.ci.NM[,2]
    tau.vec <- c(model$ORtau.coef, model$ORtau.ci[1], model$ORtau.ci[2])
    range.1 <- range(model$ORd1.ci[1],model$ORd1.ci.NM[,1], model$ORz1.ci[1], model$ORtau.ci[1],
                     model$ORd1.ci[2],model$ORd1.ci.NM[,2], model$ORz1.ci[2], model$ORtau.ci[2])

    coef.vec.0 <- c(model$ORd0, model$ORz0)
    lower.vec.0 <- c(model$ORd0.ci[1], model$ORz0.ci[1])
    upper.vec.0 <- c(model$ORd0.ci[2], model$ORz0.ci[2])
    coef.vec.0.NM <- model$ORd0.NM
    lower.vec.0.NM <- model$ORd0.ci.NM[,1]
    upper.vec.0.NM <- model$ORd0.ci.NM[,2]
    range.0 <- range(model$ORd0.ci[1],model$ORd0.ci.NM[,1], model$ORz0.ci[1], model$ORtau.ci[1],
                     model$ORd0.ci[2],model$ORd0.ci.NM[,2], model$ORz0.ci[2], model$ORtau.ci[2])

    coef.vec.avg <- c(model$ORd.avg, model$ORz.avg)
    lower.vec.avg <- c(model$ORd.avg.ci[1], model$ORz.avg.ci[1])
    upper.vec.avg <- c(model$ORd.avg.ci[2], model$ORz.avg.ci[2])
    coef.vec.avg.NM <- model$ORd.avg.NM
    lower.vec.avg.NM <- model$ORd.avg.ci.NM[,1]
    upper.vec.avg.NM <- model$ORd.avg.ci.NM[,2]
    range.avg <- range(model$ORd.avg.ci[1], model$ORd.avg.ci.NM[,1],model$ORz.avg.ci[1], model$ORtau.ci[1],
                       model$ORd.avg.ci[2],model$ORd.avg.ci.NM[,2], model$ORz.avg.ci[2], model$ORtau.ci[2])
  }
  else if (logit=="logOR"){
    coef.vec.1 <- c(model$logORd1, model$logORz1)
    lower.vec.1 <- c(model$logORd1.ci[1], model$logORz1.ci[1])
    upper.vec.1 <- c(model$logORd1.ci[2], model$logORz1.ci[2])
    coef.vec.1.NM <- model$logORd1.NM
    lower.vec.1.NM <- model$logORd1.ci.NM[,1]
    upper.vec.1.NM <- model$logORd1.ci.NM[,2]
    tau.vec <- c(model$logORtau.coef, model$logORtau.ci[1], model$logORtau.ci[2])
    range.1 <- range(model$logORd1.ci[1],model$logORd1.ci.NM[,1], model$logORz1.ci[1], model$logORtau.ci[1],
                     model$logORd1.ci[2],model$logORd1.ci.NM[,2], model$logORz1.ci[2], model$logORtau.ci[2])

    coef.vec.0 <- c(model$logORd0, model$logORz0)
    lower.vec.0 <- c(model$logORd0.ci[1], model$logORz0.ci[1])
    upper.vec.0 <- c(model$logORd0.ci[2], model$logORz0.ci[2])
    coef.vec.0.NM <- model$logORd0.NM
    lower.vec.0.NM <- model$logORd0.ci.NM[,1]
    upper.vec.0.NM <- model$logORd0.ci.NM[,2]
    range.0 <- range(model$logORd0.ci[1],model$logORd0.ci.NM[,1], model$logORz0.ci[1], model$logORtau.ci[1],
                     model$logORd0.ci[2],model$logORd0.ci.NM[,2], model$logORz0.ci[2], model$logORtau.ci[2])

    coef.vec.avg <- c(model$logORd.avg, model$logORz.avg)
    lower.vec.avg <- c(model$logORd.avg.ci[1], model$logORz.avg.ci[1])
    upper.vec.avg <- c(model$logORd.avg.ci[2], model$logORz.avg.ci[2])
    coef.vec.avg.NM <- model$logORd.avg.NM
    lower.vec.avg.NM <- model$logORd.avg.ci.NM[,1]
    upper.vec.avg.NM <- model$logORd.avg.ci.NM[,2]
    range.avg <- range(model$logORd.avg.ci[1], model$logORd.avg.ci.NM[,1],model$logORz.avg.ci[1], model$logORtau.ci[1],
                       model$logORd.avg.ci[2],model$logORd.avg.ci.NM[,2], model$logORz.avg.ci[2], model$logORtau.ci[2])
  }
  else{
    coef.vec.1 <- c(model$d1, model$z1)
    lower.vec.1 <- c(model$d1.ci[1], model$z1.ci[1])
    upper.vec.1 <- c(model$d1.ci[2], model$z1.ci[2])
    coef.vec.1.NM <- model$d1.NM
    lower.vec.1.NM <- model$d1.ci.NM[,1]
    upper.vec.1.NM <- model$d1.ci.NM[,2]
    tau.vec <- c(model$tau.coef, model$tau.ci[1], model$tau.ci[2])
    range.1 <- range(model$d1.ci[1],model$d1.ci.NM[,1], model$z1.ci[1], model$tau.ci[1],
                     model$d1.ci[2],model$d1.ci.NM[,2], model$z1.ci[2], model$tau.ci[2])

    coef.vec.0 <- c(model$d0, model$z0)
    lower.vec.0 <- c(model$d0.ci[1], model$z0.ci[1])
    upper.vec.0 <- c(model$d0.ci[2], model$z0.ci[2])
    coef.vec.0.NM <- model$d0.NM
    lower.vec.0.NM <- model$d0.ci.NM[,1]
    upper.vec.0.NM <- model$d0.ci.NM[,2]
    range.0 <- range(model$d0.ci[1],model$d0.ci.NM[,1], model$z0.ci[1], model$tau.ci[1],
                     model$d0.ci[2],model$d0.ci.NM[,2], model$z0.ci[2], model$tau.ci[2])

    coef.vec.avg <- c(model$d.avg, model$z.avg)
    lower.vec.avg <- c(model$d.avg.ci[1], model$z.avg.ci[1])
    upper.vec.avg <- c(model$d.avg.ci[2], model$z.avg.ci[2])
    coef.vec.avg.NM <- model$d.avg.NM
    lower.vec.avg.NM <- model$d.avg.ci.NM[,1]
    upper.vec.avg.NM <- model$d.avg.ci.NM[,2]
    range.avg <- range(model$d.avg.ci[1], model$d.avg.ci.NM[,1],model$z.avg.ci[1], model$tau.ci[1],
                       model$d.avg.ci[2],model$d.avg.ci.NM[,2], model$z.avg.ci[2], model$tau.ci[2])
  }






  return(list(coef.vec.1 = coef.vec.1, lower.vec.1 = lower.vec.1, upper.vec.1 = upper.vec.1,coef.vec.1.NM=coef.vec.1.NM,lower.vec.1.NM=lower.vec.1.NM, upper.vec.1.NM= upper.vec.1.NM,
              coef.vec.0 = coef.vec.0, lower.vec.0 = lower.vec.0, upper.vec.0 = upper.vec.0,coef.vec.0.NM=coef.vec.0.NM,lower.vec.0.NM=lower.vec.0.NM, upper.vec.0.NM= upper.vec.0.NM,
              coef.vec.avg = coef.vec.avg, lower.vec.avg = lower.vec.avg, upper.vec.avg = upper.vec.avg,coef.vec.avg.NM=coef.vec.avg.NM,lower.vec.avg.NM=lower.vec.avg.NM, upper.vec.avg.NM= upper.vec.avg.NM,
              tau.vec = tau.vec,
              range.1 = range.1, range.0 = range.0, range.avg = range.avg))
}

pval = function(x, xhat,seu=0){
  if (is.na(xhat)) {
    out =NA
  }
  else{
    if (xhat == seu) {out <- 1}
    else {
      out <- 2 * min(sum(x > seu,na.rm=TRUE), sum(x < seu,na.rm=TRUE)) / length(x)
    }
  }

  return(min(out, 1))

}


#' @import stats
#' @importFrom MASS mvrnorm

sim_multi=function(n=1000, NM=3,
                   binaryOutcome = FALSE,
                   coeff, correlation=c(0.9,0.6,0.3),
                   covariables){
  Treatment=sample(0:1,n,replace=TRUE)
  data=data.frame(Intercept=1,Treatment=Treatment)


  lengthcovariables <- dim(covariables)[1]
  if(!is.null(covariables)){
    for(lc in 1:dim(covariables)[2]){
      if( length(covariables[,lc])!= n ){
        stop("Not all covariables are of length n.")
      }
      assign(names(covariables)[lc],covariables[,lc])
    }
    data=cbind(data,covariables)

  }



  nuplet=unique(data)



  ntre=c("Intercept","Treatment")
  nmed=paste("M",seq(1,NM),sep="")
  row.names(coeff)=c(nmed,"Outcome")

  if(!is.null(covariables)){
    ncov=paste("C",seq(1,dim(covariables)[2]),sep="")
    colnames(coeff)=c(ntre,ncov,nmed)
  }
  else{
    colnames(coeff)=c(ntre,nmed)
  }




  Valuev=NULL
  for(i in 1:dim(nuplet)[1]){
    Valuet=NULL
    for (j in 1:(dim(nuplet)[2]-1)){
      Valuet=paste(Valuet,paste(nuplet[i,-1])[j],sep="")
    }
    Valuev=c(Valuev,Valuet)
  }
  cf.med.names=NULL
  for(nm in 1:NM){
    cf.med.names=c(cf.med.names,paste(nmed[nm],Valuev,sep="."))
  }

  muM=NULL
  for (nm in 1:NM){
    for(i in 1:dim(nuplet)[1]){
      muM=c(muM,sum(coeff[nm,1:(ncol(coeff)-NM)]*nuplet[i,]))
    }
  }

  Sigma=matrix(0,length(muM),length(muM))
  u=nm=1
  v=dim(nuplet)[1]
  for(nm in 1:NM){
    Sigma[u:v,u:v]=matrix(1,dim(nuplet)[1],dim(nuplet)[1])
    nm=nm+1
    u=v+1
    v=dim(nuplet)[1]*nm
  }

  a=seq(1,length(muM),by=dim(nuplet)[1])

  l=1
  i=1
  while(i<NM){
    u=a[i]
    for(k in (i+1):(length(a))){
      v=a[k]
      w=v+dim(nuplet)[1]
      Sigma[u:(u+dim(nuplet)[1]-1),v:(w-1)]=Sigma[v:(w-1),u:(u+dim(nuplet)[1]-1)]=matrix(correlation[l],dim(nuplet)[1],dim(nuplet)[1])
      l=l+1
    }
    i=i+1
  }

  cf.data=MASS::mvrnorm(n=n,muM,Sigma,tol=10)
  cf.data=as.data.frame(cf.data)
  names(cf.data)=cf.med.names
  cf.data$Treatment=Treatment



  for (i in 1:dim(nuplet)[1]){
    transct=cf.data[,paste(nmed,Valuev[i],sep=".")]
    if (binaryOutcome==TRUE){
      Yerror <- stats::rlogis(n,0,1)
      cf.data[,paste("Y",Valuev[i],sep=".")]=apply(coeff[NM+1,]*t(cbind(nuplet[i,],transct)),2,sum)+Yerror>0
    }
    else{
      Yerror <- stats::rnorm(n,0,1)
      cf.data[,paste("Y",Valuev[i],sep=".")]=apply(coeff[NM+1,]*t(cbind(nuplet[i,],transct)),2,sum)+Yerror
    }

  }


  for(nm in 1:NM){
    data[nmed[nm]]=NA
  }
  data$Outcome=NA
  data=data[,-1]

  com=c()
  for (i in 1:dim(nuplet)[1]){
    com = c(com,parse(text= paste(paste(names(nuplet)[-1],nuplet[i,-1], sep = "=="), collapse = " & ")))
  }
  for (i in 1:dim(nuplet)[1]){
    for(nm in 1:NM){
      data[nmed[nm]][which(eval(com[i])),]=cf.data[,paste(nmed[nm],Valuev[i],sep=".")][which(eval(com[i]))]
    }
    data$Outcome[which(eval(com[i]))]=cf.data[,paste("Y",Valuev[i],sep=".")][which(eval(com[i]))]
  }

  return(list(data=data,cf.data=cf.data,coeff=coeff,Sigma=Sigma))
}

order.data = function(Exposure,Outcome,Mediators,P){
  J=dim(Mediators)[1]
  K=dim(Mediators)[2]

  z=matrix(0,(K+1)*J,1)
  X=matrix(0,(K+1)*J,(P+1)*K+P)
  i=1
  p=1
  for(k in 1:K){
    z[i:(i+J-1),1]=Mediators[,k]
    X[i:(i+J-1),p:(p+P-1)]=as.matrix(Exposure[1:J,1:P])
    i=i+J
    p=p+P
  }

  z[i:(i+J-1),1]=Outcome
  X[seq((K+1)*J-J+1,(K+1)*J),seq(P*K+1,(P+1)*K)]=as.matrix(Mediators)
  X[seq((K+1)*J-J+1,(K+1)*J),((P+1)*K+1):((P+1)*K+P)]=as.matrix(Exposure)

  group=c(rep(seq(1,K),each=P),seq(1,K),K+1)
  X=X[,order(group)]
  group=c(rep(seq(1,K),each=P+1),K+1)
  return(list(z,X,group))
}

#' summary.mm
#'
#' \code{summary.mm} is used to display the results of the mediation analyzes done with \code{multimediate}.
#'
#'
#' @param object element of the class \code{mm}.
#' @param opt a character string indicating the details of the analysis "navg" for the average causal effects for t=0,1 and "avg"  for the average causal effects.
#' @param logit a character string indicating, when the outcome is binary, the scale of the average causal effects. "effects" for average causal effects, " OR" average causal effects on OR scale, "logOR" average causal effects on logOR scale and "all" for all scale.
#' @param ... additional arguments affecting the summary produced
#'
#' @return table summarizing the causal analysis
#' @export
#'

summary.mm = function(object,opt="navg",logit="all",...){
    nom.navg=c("ACME.joint.treat","PM(treat)","ACME.joint.control","PM(control)",paste(c("ACME.treat.","PM(treat).","ACME.control.","PM(control)."),rep(object$mediator,each=4),sep=""),"ADE.treat","ADE.control","Total Effect")
    nom.avg=c("ACME.joint","PM.joint",paste(c("ACME.","PM."),rep(object$mediator,each=2),sep=""),"ADE","Total Effect")


  if (length(object$mediator)>1){
    navg=data.frame("."        =nom.navg,
                    Estimation=round(c(object$d1,object$n1,object$d0,object$n0,triout.NM(object$d1.NM,object$n1.NM,object$d0.NM,object$n0.NM),object$z1,object$z0,object$tau.coef),4),
                    IC.inf    =round(c(object$d1.ci[1],object$n1.ci[1],object$d0.ci[1],object$n0.ci[1],triout.ci.NM(object$d1.ci.NM,object$n1.ci.NM,object$d0.ci.NM,object$n0.ci.NM)[,1],object$z1.ci[1],object$z0.ci[1],object$tau.ci[1]),4),
                    IC.sup    =round(c(object$d1.ci[2],object$n1.ci[2],object$d0.ci[2],object$n0.ci[2],triout.ci.NM(object$d1.ci.NM,object$n1.ci.NM,object$d0.ci.NM,object$n0.ci.NM)[,2],object$z1.ci[2],object$z0.ci[2],object$tau.ci[2]),4),
                    P.val     =round(c(object$d1.p,object$n1.p,object$d0.p,object$n0.p,triout.NM(object$d1.p.NM,object$n1.p.NM,object$d0.p.NM,object$n0.p.NM),object$z1.p,object$z0.p,object$tau.p),4)
    )
    avg=data.frame("."        =nom.avg,
                   Estimation=round(c(object$d.avg,object$n.avg,triout.avg.NM(object$d.avg.NM,object$n.avg.NM),object$z.avg,object$tau.coef),4),
                   IC.inf    =round(c(object$d.avg.ci[1],object$n.avg.ci[1],triout.ci.avg.NM(object$d.avg.ci.NM,object$n.avg.ci.NM)[,1],object$z.avg.ci[1],object$tau.ci[1]),4),
                   IC.sup    =round(c(object$d.avg.ci[2],object$n.avg.ci[2],triout.ci.avg.NM(object$d.avg.ci.NM,object$n.avg.ci.NM)[,2],object$z.avg.ci[2],object$tau.ci[2]),4),
                   P.val     =round(c(object$d.avg.p,object$n.avg.p,triout.avg.NM(object$d.avg.p.NM,object$n.avg.p.NM),object$z.avg.p,object$tau.p),4)
    )

    if (!is.null(object$model.y$family)){
      if (object$model.y$family$link=="logit"){

        warning("The proportions mediated on the OR scale can be considered if the outcome is rare, otherwise the proportions mediated on effects scale and/or logOR scale have to be considered.")
        ORnavg=data.frame("."        =paste("OR",nom.navg),
                          Estimation=round(c(object$ORd1,object$ORn1,object$ORd0,object$ORn0,triout.NM(object$ORd1.NM,object$ORn1.NM,object$ORd0.NM,object$ORn0.NM),object$ORz1,object$ORz0,object$ORtau.coef),4),
                          IC.inf    =round(c(object$ORd1.ci[1],object$ORn1.ci[1],object$ORd0.ci[1],object$ORn0.ci[1],triout.ci.NM(object$ORd1.ci.NM,object$ORn1.ci.NM,object$ORd0.ci.NM,object$ORn0.ci.NM)[,1],object$ORz1.ci[1],object$ORz0.ci[1],object$ORtau.ci[1]),4),
                          IC.sup    =round(c(object$ORd1.ci[2],object$ORn1.ci[2],object$ORd0.ci[2],object$ORn0.ci[2],triout.ci.NM(object$ORd1.ci.NM,object$ORn1.ci.NM,object$ORd0.ci.NM,object$ORn0.ci.NM)[,2],object$ORz1.ci[2],object$ORz0.ci[2],object$ORtau.ci[2]),4),
                          P.val     =round(c(object$ORd1.p,object$ORn1.p,object$ORd0.p,object$ORn0.p,triout.NM(object$ORd1.p.NM,object$ORn1.p.NM,object$ORd0.p.NM,object$ORn0.p.NM),object$ORz1.p,object$ORz0.p,object$ORtau.p),4)
        )
        ORavg=data.frame("."        =paste("OR",nom.avg),
                         Estimation=round(c(object$ORd.avg      ,object$ORn.avg      ,triout.avg.NM(   object$ORd.avg.NM                   ,object$ORn.avg.NM)       ,object$ORz.avg      ,object$ORtau.coef) ,4),
                         IC.inf    =round(c(object$ORd.avg.ci[1],object$ORn.avg.ci[1],triout.ci.avg.NM(object$ORd.avg.ci.NM             ,object$ORn.avg.ci.NM)[,1],object$ORz.avg.ci[1],object$ORtau.ci[1]),4),
                         IC.sup    =round(c(object$ORd.avg.ci[2],object$ORn.avg.ci[2],triout.ci.avg.NM(object$ORd.avg.ci.NM             ,object$ORn.avg.ci.NM)[,2],object$ORz.avg.ci[2],object$ORtau.ci[2]),4),
                         P.val     =round(c(object$ORd.avg.p    ,object$ORn.avg.p    ,triout.avg.NM(   object$ORd.avg.p.NM                 ,object$ORn.avg.p.NM)     ,object$ORz.avg.p    ,object$ORtau.p)    ,4)
        )

        logORnavg=data.frame("."        =paste("logOR",nom.navg),
                             Estimation=round(c(object$logORd1,               object$logORn1,      object$logORd0,      object$logORn0,      triout.NM(   object$logORd1.NM,   object$logORn1.NM,   object$logORd0.NM,   object$logORn0.NM),       object$logORz1,      object$logORz0,      object$logORtau.coef), 4),
                             IC.inf    =round(c(object$logORd1.ci[1],         object$logORn1.ci[1],object$logORd0.ci[1],object$logORn0.ci[1],triout.ci.NM(object$logORd1.ci.NM,object$logORn1.ci.NM,object$logORd0.ci.NM,object$logORn0.ci.NM)[,1],object$logORz1.ci[1],object$logORz0.ci[1],object$logORtau.ci[1]),4),
                             IC.sup    =round(c(object$logORd1.ci[2],         object$logORn1.ci[2],object$logORd0.ci[2],object$logORn0.ci[2],triout.ci.NM(object$logORd1.ci.NM,object$logORn1.ci.NM,object$logORd0.ci.NM,object$logORn0.ci.NM)[,2],object$logORz1.ci[2],object$logORz0.ci[2],object$logORtau.ci[2]),4),
                             P.val     =round(c(object$logORd1.p,             object$logORn1.p,    object$logORd0.p,    object$logORn0.p,    triout.NM(   object$logORd1.p.NM, object$logORn1.p.NM, object$logORd0.p.NM, object$logORn0.p.NM),     object$logORz1.p,    object$logORz0.p,    object$logORtau.p),    4)
        )
        logORavg=data.frame("."        =paste("logOR",nom.avg),
                            Estimation=round(c(object$logORd.avg,object$logORn.avg,triout.avg.NM(object$logORd.avg.NM,object$logORn.avg.NM),object$logORz.avg,object$logORtau.coef),4),
                            IC.inf    =round(c(object$logORd.avg.ci[1],object$logORn.avg.ci[1],triout.ci.avg.NM(object$logORd.avg.ci.NM,object$logORn.avg.ci.NM)[,1],object$logORz.avg.ci[1],object$logORtau.ci[1]),4),
                            IC.sup    =round(c(object$logORd.avg.ci[2],object$logORn.avg.ci[2],triout.ci.avg.NM(object$logORd.avg.ci.NM,object$logORn.avg.ci.NM)[,2],object$logORz.avg.ci[2],object$logORtau.ci[2]),4),
                            P.val     =round(c(object$logORd.avg.p,object$logORn.avg.p,triout.avg.NM(object$logORd.avg.p.NM,object$logORn.avg.p.NM),object$logORz.avg.p,object$logORtau.p),4)
        )
      }}
    pmtest= c(object$d1,object$d0,object$d1.NM,object$d0.NM,object$z1,object$z0,object$tau.coef)
    if(sum(pmtest>0)!=length(pmtest)){
      warning("Proportion mediated warning : This quantity makes sense only when the sign the causal mediated effects (i.e., the numerator) are the same as the sign of the average total effect (i.e., the denominator) and when the total effect is bigger than the mediated effect. Confidence intervals may be meaningless when the mediated and/or direct effects have a different sign.")
    }
  }
  else {
    navg=data.frame("."        =c("ACME.treat","PM(treat)","ACME.control","PM(control)","ADE.treat","ADE.control","Total Effect"),
                    Estimation=round(c(object$d1,object$n1,object$d0,object$n0,object$z1,object$z0,object$tau.coef),4),
                    IC.inf    =round(c(object$d1.ci[1],object$n1.ci[1],object$d0.ci[1],object$n0.ci[1],object$z1.ci[1],object$z0.ci[1],object$tau.ci[1]),4),
                    IC.sup    =round(c(object$d1.ci[2],object$n1.ci[2],object$d0.ci[2],object$n0.ci[2],object$z1.ci[2],object$z0.ci[2],object$tau.ci[2]),4),
                    P.val     =round(c(object$d1.p,object$n1.p,object$d0.p,object$n0.p,object$z1.p,object$z0.p,object$tau.p),4)
    )

    avg=data.frame("."        =c("ACME","PM","ADE","Total Effect"),
                   Estimation=round(c(object$d.avg,object$n.avg,object$z.avg,object$tau.coef),4),
                   IC.inf    =round(c(object$d.avg.ci[1],object$n.avg.ci[1],object$z.avg.ci[1],object$tau.ci[1]),4),
                   IC.sup    =round(c(object$d.avg.ci[2],object$n.avg.ci[2],object$z.avg.ci[2],object$tau.ci[2]),4),
                   P.val     =round(c(object$d.avg.p,object$n.avg.p,object$z.avg.p,object$tau.p),4)
    )
    if (!is.null(object$model.y$family)){
      if (object$model.y$family$link=="logit"){
        warning("The proportion mediated on the OR scale can be considered if the outcome is rare, otherwise the proportion mediated on effect scale and/or logOR scale have to be considered.")

        ORnavg=data.frame("."        =c("OR.ACME.treat","OR.PM(treat)","OR.ACME.control","OR.PM(control)","OR.ADE.treat","OR.ADE.control","OR.Total Effect"),
                          Estimation=round(c(object$ORd1,object$ORn1,object$ORd0,object$ORn0,object$ORz1,object$ORz0,object$ORtau.coef),4),
                          IC.inf    =round(c(object$ORd1.ci[1],object$ORn1.ci[1],object$ORd0.ci[1],object$ORn0.ci[1],object$ORz1.ci[1],object$ORz0.ci[1],object$ORtau.ci[1]),4),
                          IC.sup    =round(c(object$ORd1.ci[2],object$ORn1.ci[2],object$ORd0.ci[2],object$ORn0.ci[2],object$ORz1.ci[2],object$ORz0.ci[2],object$ORtau.ci[2]),4),
                          P.val     =round(c(object$ORd1.p,object$ORn1.p,object$ORd0.p,object$ORn0.p,object$ORz1.p,object$ORz0.p,object$ORtau.p),4)
        )

        ORavg=data.frame("."        =c("OR.ACME","OR.PM","OR.ADE","OR.Total Effect"),
                         Estimation=round(c(object$ORd.avg,object$ORn.avg,object$ORz.avg,object$ORtau.coef),4),
                         IC.inf    =round(c(object$ORd.avg.ci[1],object$ORn.avg.ci[1],object$ORz.avg.ci[1],object$ORtau.ci[1]),4),
                         IC.sup    =round(c(object$ORd.avg.ci[2],object$ORn.avg.ci[2],object$ORz.avg.ci[2],object$ORtau.ci[2]),4),
                         P.val     =round(c(object$ORd.avg.p,object$ORn.avg.p,object$ORz.avg.p,object$ORtau.p),4)
        )

        logORnavg=data.frame("."        =c("logOR.ACME.treat","logOR.PM(treat)","logOR.ACME.control","logOR.PM(control)","logOR.ADE.treat","logOR.ADE.control","logOR.Total Effect"),
                             Estimation=round(c(object$logORd1,object$logORn1,object$logORd0,object$logORn0,object$logORz1,object$logORz0,object$logORtau.coef),4),
                             IC.inf    =round(c(object$logORd1.ci[1],object$logORn1.ci[1],object$logORd0.ci[1],object$logORn0.ci[1],object$logORz1.ci[1],object$logORz0.ci[1],object$logORtau.ci[1]),4),
                             IC.sup    =round(c(object$logORd1.ci[2],object$logORn1.ci[2],object$logORd0.ci[2],object$logORn0.ci[2],object$logORz1.ci[2],object$logORz0.ci[2],object$logORtau.ci[2]),4),
                             P.val     =round(c(object$logORd1.p,object$logORn1.p,object$logORd0.p,object$logORn0.p,object$logORz1.p,object$logORz0.p,object$logORtau.p),4)
        )
        logORavg=data.frame("."        =c("logOR.ACME","logOR.PM","logOR.ADE","logOR.Total Effect"),
                            Estimation=round(c(object$logORd.avg,object$logORn.avg,object$logORz.avg,object$logORtau.coef),4),
                            IC.inf    =round(c(object$logORd.avg.ci[1],object$logORn.avg.ci[1],object$logORz.avg.ci[1],object$logORtau.ci[1]),4),
                            IC.sup    =round(c(object$logORd.avg.ci[2],object$logORn.avg.ci[2],object$logORz.avg.ci[2],object$logORtau.ci[2]),4),
                            P.val     =round(c(object$logORd.avg.p,object$logORn.avg.p,object$logORz.avg.p,object$logORtau.p),4)
        )
      }}
    pmtest= c(object$d1,object$d0,object$z1,object$z0,object$tau.coef)
    if(sum(pmtest>0)!=length(pmtest)){
      warning("Proportion mediated warning : This quantity makes sense only when the sign the causal mediated effects (i.e., the numerator) are the same as the sign of the average total effect (i.e., the denominator) and when the total effect is bigger than the mediated effect. Confidence intervals may be meaningless when the mediated and/or direct effects have a different sign.")
    }
  }
  if (opt=="avg"){
    if (is.null(object$model.y$family) || object$model.y$family$link=="probit")
    {res=avg}
    else{
      if (object$model.y$family$link=="logit" & logit=="all"){
        res=cbind(avg,ORavg,logORavg)
      }
      else if (object$model.y$family$link=="logit" & logit=="OR"){
        res=ORavg
      }
      else if (object$model.y$family$link=="logit" & logit=="logOR"){
        res=logORavg
      }
      else{
        res=avg
      }
    }

  }
  else{

    if (is.null(object$model.y$family) || object$model.y$family$link=="probit")
    {res=navg}
    else {
      if (object$model.y$family$link=="logit" & logit=="all"){
        res=cbind(navg,ORnavg,logORnavg)
      }
      else if (object$model.y$family$link=="logit" & logit=="OR"){
        res=ORnavg
      }
      else if (object$model.y$family$link=="logit" & logit=="logOR"){
        res=logORnavg
      }
      else{
        res=navg
      }
    }

  }
  return(res)
}

#' multimediate
#'
#'
#' \code{multimediate} estimates several quantities in causal mediation analysis, including the average causal mediation effect (indirect effect), average direct effect, proportion mediated, and total effect, in the presence of multiple uncausally related mediators.
#'
#' For binary outcomes, it also estimates average causal mediation effects on the odds ratio (OR) and log-odds (logOR) scales.
#'
#' For survival outcomes, \code{multimediate} additionally estimates average causal mediation effects on cases per person-year scale.
#'
#'@param lmodel.m list of fitted models object for mediators. Can be of class \code{lm}, \code{polr}, \code{glm}.
#'@param correlated a logical value. if \code{FALSE} a identity matrix is used for the matrix of correlation of mediators; if \code{TRUE} matrix of correlation is estimated. Default is 'FALSE'.
#'@param model.y a fitted model object for the outcome. Can be of class \code{lm}, \code{polr}, \code{glm} or \code{aalen}.
#'@param treat a character string indicating the name of the treatment variable used in the models. The treatment can be either binary (integer or a two-valued factor) or continuous (numeric).
#'@param treat.value value of the treatment variable used as the treatment condition. Default is 1.
#'@param control.value value of the treatment variable used as the control condition. Default is 0.
#'@param J number of Monte Carlo draws for quasi-Bayesian approximation.
#'@param conf.level level of the returned two-sided confidence intervals. Default is to return the 2.5 and 97.5 percentiles of the simulated quantities.
#'@param fun the function used to compute the point estimate of the effects of interest from its empirical distribution. The function \code{mean} or \code{median} can be used. Default is the function \code{mean}.
#'@param data dataset with all variables used in the mediator and outcome models
#'@param peryr the number of person-years to multiply the additive estimator to obtain results in scale of cases per person-years (only applicable to the survival outcome)
#'@param verbose Logical. If \code{TRUE} (default), messages and a progress bar are displayed during execution.
#'
#'
#'
#'@return multimediate returns an object of class \code{mm}, a list that contains at least the components listed below.
#' The function \code{summary} (i.e., \code{summary.mm}) can be used to obtain a table of the results.
#' \itemize{
#'   \item \code{model.y}: the fitted outcome model.
#'   \item \code{model.m}: a list of fitted mediator models, one for each mediator.
#'   \item \code{treatment}: a character string indicating the name of the treatment variable used in the models.
#'   \item \code{treat.value}: value of the treatment variable used as the treatment condition.
#'   \item \code{control.value}: value of the treatment variable used as the control condition.
#'   \item \code{sims}: the number of Monte Carlo draws for quasi-Bayesian approximation.
#' }
#'
#' @examples
#' # Load example data
#' data(data1)
#' summary(data1)
#'
#' # Fit mediator models
#' M1reg <- lm(M1 ~ Treatment + C1 + C2, data = data1)
#' M2reg <- lm(M2 ~ Treatment + C1 + C3, data = data1)
#' M3reg <- lm(M3 ~ Treatment + C1, data = data1)
#'
#' # Fit outcome model
#' Yreg <- lm(Outcome ~ Treatment + M1 + M2 + M3 + C1 + C2 + C3, data = data1)
#'
#' # Perform multiple mediation analysis (may take some time)
#'
#' med.analysis <- multimediate(
#'   lmodel.m = list(M1reg, M2reg, M3reg),
#'   correlated = TRUE,
#'   model.y = Yreg,
#'   treat = "Treatment",
#'   treat.value = 1,
#'   control.value = 0,
#'   J = 100,
#'   conf.level = 0.95,
#'   verbose = FALSE
#' )
#'
#' summary(med.analysis, opt = "avg")
#'
#'
#' @export
#'
#' @importFrom MASS mvrnorm
#' @importFrom mvtnorm rmvnorm
#' @importFrom utils txtProgressBar
#' @importFrom utils setTxtProgressBar
#' @importFrom timereg aalen


multimediate = function(lmodel.m,
                        correlated = FALSE,
                        model.y,
                        treat,
                        treat.value = 1,
                        control.value = 0,
                        J = 1000,
                        conf.level = 0.95,
                        fun = mean,
                        data = NULL,
                        peryr = 100000,
                        verbose = TRUE) {
  if (inherits(model.y, "aalen")) {
    return(
      multimediate_survival(
        lmodel.m = lmodel.m,
        correlated = correlated,
        model.y = model.y,
        treat = treat,
        treat.value = treat.value,
        control.value = control.value,
        J = J,
        conf.level = conf.level,
        fun = fun,
        data = data,
        peryr = peryr,
        verbose = verbose
      )
    )
  }
  else{
    N = dim(lmodel.m[[1]]$model)[1]
    NM = length(lmodel.m)

    for (nm in 1:NM) {
      testmm = inherits(lmodel.m[[nm]], c("lm", "glm", "polr"))
      if (testmm == FALSE) {
        stop("Mediator's model not implemented yet.")
      }

      if (!inherits(lmodel.m[[nm]], "lm")) {
        for (c in 1:dim(lmodel.m[[nm]]$model)[2]) {
          if (!is.factor(lmodel.m[[nm]]$model[, c])) {
            stop(
              "covariate ",
              names(lmodel.m[[nm]]$model)[c],
              " in mediators models must be discretize and/or factorize."
            )
          }
        }


      }
    }

    testy = inherits(model.y, c("lm", "glm", "polr", "aalen"))
    if (testy == FALSE) {
      stop("Outcome's model not implemented yet.")
    }

    mediator = c()
    MModel = list()
    for (nm in 1:NM) {
      MModel[[nm]] = rmvnorm(J,
                             mean = c(coef(lmodel.m[[nm]]), lmodel.m[[nm]]$zeta),
                             sigma = vcov(lmodel.m[[nm]]))
      mediator = c(mediator, names(lmodel.m[[nm]]$model)[1])
    }

    if (correlated == TRUE) {
      mcov = CorCond(e = 10^(-10), lmodel.m)
      error = mvrnorm(
        n = N * J,
        mu = rep(0, NM),
        mcov$sigmaestim,
        tol = 100
      )
      cov = mcov$sigmaestim
      cor = mcov$correstim
    }
    else{
      error = mvrnorm(n = N * J, mu = rep(0, NM), diag(rep(1, NM)))
      cov = diag(rep(1, NM))
    }
    YModel = rmvnorm(J,
                     mean = c(coef(model.y), model.y$zeta),
                     sigma = vcov(model.y))


    if (!is.null(model.y$family$link)) {
      if (model.y$family$link == "logit") {
        Yerror <- rlogis(N, 0, 1)
      }
      else{
        Yerror <- rnorm(N, 0, 1)
      }
    }
    else {
      Yerror <- rnorm(N, 0, 1)
    }
    PredictM1 <- PredictM0 <- PredictM1b <- PredictM0b <- array(0, dim = c(J, N, NM))


    if (isTRUE(verbose))
      message("Simulation of counterfactuals mediators")
    if (isTRUE(verbose))
      pb <- txtProgressBar(
        min = 0,
        max = NM,
        style = 3,
        title = "Simulation of counterfactuals mediators"
      )

    for (nm in 1:NM) {
      pred.data.t <- pred.data.c <- model.frame(lmodel.m[[nm]])

      if (is.factor(lmodel.m[[nm]]$model[, treat])) {
        pred.data.t[, treat] <- factor(treat.value, levels = levels(lmodel.m[[nm]]$model[, treat]))
        pred.data.c[, treat] <- factor(control.value, levels = levels(lmodel.m[[nm]]$model[, treat]))
      }
      else {
        pred.data.t[, treat] <- treat.value
        pred.data.c[, treat] <- control.value
      }


      if (inherits(lmodel.m[[nm]], "polr")) {
        mmat.t <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.t)
        mmat.c <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.c)
        mmat.t = mmat.t[, -1]
        mmat.c = mmat.c[, -1]

        if (is.null(dim(mmat.t))) {
          muM1 <- tcrossprod(MModel[[nm]][, 1], mmat.t)
          muM0 <- tcrossprod(MModel[[nm]][, 1], mmat.c)
        }
        else{
          muM1 <- tcrossprod(MModel[[nm]][, 1:dim(mmat.t)[2]], mmat.t)
          muM0 <- tcrossprod(MModel[[nm]][, 1:dim(mmat.t)[2]], mmat.c)
        }


        PredictM1[, , nm] <- PredictM1b[, , nm] <- array(muM1, dim = c(J, N)) + array(error[, nm], dim =
                                                                                        c(J, N))
        PredictM0[, , nm] <- PredictM0b[, , nm] <- array(muM0, dim = c(J, N)) + array(error[, nm], dim =
                                                                                        c(J, N))

        seuil = c(-Inf, lmodel.m[[nm]]$zeta, Inf)

        for (k in 1:length(lmodel.m[[nm]]$lev)) {
          for (j in 1:J) {
            a = which(PredictM1b[j, , nm] > seuil[k] &
                        PredictM1b[j, , nm] <= seuil[k + 1])
            b = which(PredictM0b[j, , nm] > seuil[k] &
                        PredictM0b[j, , nm] <= seuil[k + 1])
            PredictM1[j, a, nm] = lmodel.m[[nm]]$lev[k]
            PredictM0[j, b, nm] = lmodel.m[[nm]]$lev[k]
          }
        }
      }
      else{
        mmat.t <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.t)
        mmat.c <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.c)

        muM1 <- tcrossprod(MModel[[nm]], mmat.t)
        muM0 <- tcrossprod(MModel[[nm]], mmat.c)

        PredictM1[, , nm] <- array(muM1, dim = c(J, N)) + array(error[, nm], dim =
                                                                  c(J, N))
        PredictM0[, , nm] <- array(muM0, dim = c(J, N)) + array(error[, nm], dim =
                                                                  c(J, N))
        if (inherits(lmodel.m[[nm]], "glm")) {
          PredictM1[, , nm] = (PredictM1[, , nm] > 0) * 1
          PredictM0[, , nm] = (PredictM0[, , nm] > 0) * 1
        }
      }
      if (isTRUE(verbose))
        setTxtProgressBar(pb, nm)
    }
    if (isTRUE(verbose))
      close(pb)


    effect.tmp.NM = OR.NM = array(NA, dim = c(N, J, 2, NM))
    effect.tmp = OR = array(NA, dim = c(N, J, 4))
    title = paste("Simulation of counterfactuals outcomes ", 1:4, "/4", sep =
                    "")
    for (e in 1:4) {
      tt <- switch(e, c(1, 1, 1, 0), c(0, 0, 1, 0), c(1, 0, 1, 1), c(1, 0, 0, 0))
      Pr0 <- Pr1 <- ORPr0 <- ORPr1 <- matrix(NA, nrow = N, ncol = J)
      if (NM != 1 & e <= 2) {
        Pr0.NM <- Pr1.NM <- ORPr0.NM <- ORPr1.NM <- array(NA, dim = c(N, J, NM))
      }
      if (isTRUE(verbose))
        message(title[e])
      if (isTRUE(verbose))
        pb <- txtProgressBar(
          min = 0,
          max = J,
          style = 3,
          title = title[e]
        )
      for (j in 1:J) {
        pred.data.t <- pred.data.c <- model.frame(model.y)

        cat.t <- ifelse(tt[1], treat.value, control.value)
        cat.c <- ifelse(tt[2], treat.value, control.value)

        if (is.factor(model.y$model[, treat])) {
          pred.data.t[, treat] <- factor(cat.t, levels = levels(model.y$model[, treat]))
          pred.data.c[, treat] <- factor(cat.c, levels = levels(model.y$model[, treat]))

        }
        else {
          pred.data.t[, treat] <- cat.t
          pred.data.c[, treat] <- cat.c

        }


        if (tt[3] == 1) {
          PredictMt = PredictM1[j, , ]
        }
        else {
          PredictMt = PredictM0[j, , ]
        }
        if (tt[4] == 1) {
          PredictMc = PredictM1[j, , ]
        }
        else {
          PredictMc = PredictM0[j, , ]
        }

        pred.data.t[, mediator] <- PredictMt
        pred.data.c[, mediator] <- PredictMc




        for (nm in 1:NM) {
          if (inherits(lmodel.m[[nm]], "polr")) {
            pred.data.c[, mediator[nm]] = as.factor(pred.data.c[, mediator[nm]])
            levels(pred.data.c[, mediator[nm]]) = lmodel.m[[nm]]$lev
            pred.data.t[, mediator[nm]] = as.factor(pred.data.t[, mediator[nm]])
            levels(pred.data.t[, mediator[nm]]) = lmodel.m[[nm]]$lev
          }

          if (inherits(lmodel.m[[nm]], "lm") &
              !inherits(lmodel.m[[nm]], "glm")) {
            pred.data.c[, mediator[nm]] = as.numeric(pred.data.c[, mediator[nm]])
            pred.data.t[, mediator[nm]] = as.numeric(pred.data.t[, mediator[nm]])
          }

          if (inherits(lmodel.m[[nm]], "glm")) {
            pred.data.c[, mediator[nm]] = as.factor(pred.data.c[, mediator[nm]])
            levels(pred.data.c[, mediator[nm]]) = levels(lmodel.m[[nm]]$model[, 1])
            pred.data.t[, mediator[nm]] = as.factor(pred.data.t[, mediator[nm]])
            levels(pred.data.t[, mediator[nm]]) = levels(lmodel.m[[nm]]$model[, 1])
          }
        }

        ymat.t = ymat.c = model.matrix(model.y)
        trans.t <- model.matrix(terms(model.y), data = pred.data.t)
        ymat.t[, colnames(ymat.t) %in% colnames(trans.t)] = trans.t
        ymat.t[, !(colnames(ymat.t) %in% colnames(trans.t))] = 0

        trans.c <- model.matrix(terms(model.y), data = pred.data.c)
        ymat.c[, colnames(ymat.c) %in% colnames(trans.c)] = trans.c
        ymat.c[, !(colnames(ymat.c) %in% colnames(trans.c))] = 0

        if (!inherits(model.y, "polr")) {
          Pr1[, j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t) + Yerror
          Pr0[, j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c) + Yerror
          ORPr1[, j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
          ORPr0[, j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
        }
        else{
          ymat.t = ymat.t[, -1]
          ymat.c = ymat.c[, -1]
          Pr1[, j] <- t(as.matrix(YModel[j, 1:dim(ymat.t)[2]])) %*% t(ymat.t) + Yerror
          Pr0[, j] <- t(as.matrix(YModel[j, 1:dim(ymat.c)[2]])) %*% t(ymat.c) + Yerror

          seuilY = c(-Inf, model.y$zeta, Inf)
          Pr1b = as.numeric(Pr1[, j])
          Pr0b = as.numeric(Pr0[, j])
          for (k in 1:length(model.y$lev)) {
            a = which(Pr1b > seuilY[k] & Pr1b <= seuilY[k + 1])
            b = which(Pr0b > seuilY[k] & Pr0b <= seuilY[k + 1])
            Pr1[a, j] = model.y$lev[k]
            Pr0[b, j] = model.y$lev[k]
          }
          Pr1 = matrix(as.numeric(Pr1), N, J)
          Pr0 = matrix(as.numeric(Pr0), N, J)
        }

        if (NM != 1 & e <= 2) {
          for (nm in 1:NM) {
            if (tt[3] == 1) {
              PredictMt = PredictM1[j, , nm]
            }
            else {
              PredictMt = PredictM0[j, , nm]
            }
            if (tt[1] == 1) {
              PredictWt = PredictM1[j, , -nm]
            }
            else {
              PredictWt = PredictM0[j, , -nm]
            }

            if (tt[4] == 1) {
              PredictMc = PredictM1[j, , nm]
            }
            else {
              PredictMc = PredictM0[j, , nm]
            }
            if (tt[2] == 1) {
              PredictWc = PredictM1[j, , -nm]
            }
            else {
              PredictWc = PredictM0[j, , -nm]
            }


            pred.data.t[, mediator[nm]] <- PredictMt
            pred.data.t[, mediator[-nm]] <- PredictWt
            pred.data.c[, mediator[nm]] <- PredictMc
            pred.data.c[, mediator[-nm]] <- PredictWc
            for (nmt in 1:NM) {
              if (inherits(lmodel.m[[nmt]], "polr")) {
                pred.data.c[, mediator[nmt]] = as.factor(pred.data.c[, mediator[nmt]])
                levels(pred.data.c[, mediator[nmt]]) = lmodel.m[[nmt]]$lev
                pred.data.t[, mediator[nmt]] = as.factor(pred.data.t[, mediator[nmt]])
                levels(pred.data.t[, mediator[nmt]]) = lmodel.m[[nmt]]$lev
              }

              if (inherits(lmodel.m[[nmt]], "lm") &
                  !inherits(lmodel.m[[nmt]], "glm")) {
                pred.data.c[, mediator[nmt]] = as.numeric(pred.data.c[, mediator[nmt]])
                pred.data.t[, mediator[nmt]] = as.numeric(pred.data.t[, mediator[nmt]])
              }

              if (inherits(lmodel.m[[nmt]], "glm")) {
                pred.data.c[, mediator[nmt]] = as.factor(pred.data.c[, mediator[nmt]])
                levels(pred.data.c[, mediator[nmt]]) = levels(lmodel.m[[nmt]]$model[, 1])
                pred.data.t[, mediator[nmt]] = as.factor(pred.data.t[, mediator[nmt]])
                levels(pred.data.t[, mediator[nmt]]) = levels(lmodel.m[[nmt]]$model[, 1])
              }
            }

            ymat.t = ymat.c = model.matrix(model.y)
            trans.t <- model.matrix(terms(model.y), data = pred.data.t)
            ymat.t[, colnames(ymat.t) %in% colnames(trans.t)] = trans.t
            ymat.t[, !(colnames(ymat.t) %in% colnames(trans.t))] = 0

            trans.c <- model.matrix(terms(model.y), data = pred.data.c)
            ymat.c[, colnames(ymat.c) %in% colnames(trans.c)] = trans.c
            ymat.c[, !(colnames(ymat.c) %in% colnames(trans.c))] = 0


            if (!inherits(model.y, "polr")) {
              Pr1.NM[, j, nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t) + Yerror
              Pr0.NM[, j, nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c) + Yerror
              ORPr1.NM[, j, nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
              ORPr0.NM[, j, nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
            }
            else{
              ymat.t = ymat.t[, -1]
              ymat.c = ymat.c[, -1]
              Pr1.NM[, j, nm] <- t(as.matrix(YModel[j, 1:dim(ymat.t)[2]])) %*% t(ymat.t) + Yerror
              Pr0.NM[, j, nm] <- t(as.matrix(YModel[j, 1:dim(ymat.c)[2]])) %*% t(ymat.c) + Yerror

              Pr1b.NM = as.numeric(Pr1.NM[, j, nm])
              Pr0b.NM = as.numeric(Pr0.NM[, j, nm])
              for (k in 1:length(model.y$lev)) {
                a = which(Pr1b.NM > seuilY[k] & Pr1b.NM <= seuilY[k + 1])
                b = which(Pr0b.NM > seuilY[k] & Pr0b.NM <= seuilY[k + 1])
                Pr1.NM[a, j, nm] = model.y$lev[k]
                Pr0.NM[b, j, nm] = model.y$lev[k]
              }
              Pr1.NM = array(as.numeric(Pr1.NM), dim = c(N, J, NM))
              Pr0.NM = array(as.numeric(Pr0.NM), dim = c(N, J, NM))
            }
          }
        }
        if (isTRUE(verbose))
          setTxtProgressBar(pb, j, title = title[e])
      }
      if (isTRUE(verbose))
        close(pb)

      if (!is.null(model.y$family)) {
        effect.tmp[, , e] = (Pr1 > 0) - (Pr0 > 0)
        if (model.y$family$link == "logit") {
          expit = function(x) {
            res = 1 / (1 + exp(-x))
            return(res)
          }

          OR[, , e] = ((1 - expit(ORPr0)) / expit(ORPr0)) * ((expit(ORPr1)) /
                                                               (1 - expit(ORPr1)))
        }
        if (NM != 1 & e <= 2) {
          effect.tmp.NM[, , e, ] = (Pr1.NM > 0) - (Pr0.NM > 0)
          if (model.y$family$link == "logit") {
            OR.NM[, , e, ] = ((1 - expit(ORPr0.NM)) / expit(ORPr0.NM)) * ((expit(ORPr1.NM)) /
                                                                            (1 - expit(ORPr1.NM)))
          }

        }
      }

      else {
        effect.tmp[, , e] = Pr1 - Pr0
        if (NM != 1 & e <= 2) {
          effect.tmp.NM[, , e, ] = Pr1.NM - Pr0.NM
        }
      }
    }
    if (isTRUE(verbose))
      message("Computing average point estimates together with p-values and confidence intervals")
    # Step 3.3 : Compute the effects.
    # Compute the average effects. That is, we simply take the difference accross
    # two outcome predictions under treatment and the two outcome predictions under
    # control and average across the predictions for each of the n units in the study.
    # This provides us with effect^(j)(t), which is one Monte Carlo draw of the average effect

    et1 <- effect.tmp[, , 1] # joint mediated effect delta(1)
    et2 <- effect.tmp[, , 2] # joint mediated effect delta(0)
    et3 <- effect.tmp[, , 3] # direct effect zeta(1)
    et4 <- effect.tmp[, , 4] # direct effect zeta(0)

    delta.1 <- t(as.matrix(apply(et1, 2, mean, na.rm = TRUE)))
    delta.0 <- t(as.matrix(apply(et2, 2, mean, na.rm = TRUE)))

    zeta.1 <- t(as.matrix(apply(et3, 2, mean, na.rm = TRUE)))
    zeta.0 <- t(as.matrix(apply(et4, 2, mean, na.rm = TRUE)))

    tau <- (zeta.1 + delta.0 + zeta.0 + delta.1) / 2
    nu.0 <- delta.0 / tau
    nu.1 <- delta.1 / tau
    delta.avg <- (delta.1 + delta.0) / 2
    zeta.avg <- (zeta.1 + zeta.0) / 2
    nu.avg <- (nu.1 + nu.0) / 2
    d0 <- fun(delta.0, na.rm = TRUE)
    d1 <- fun(delta.1, na.rm = TRUE)
    z1 <- fun(zeta.1, na.rm = TRUE)
    z0 <- fun(zeta.0, na.rm = TRUE)
    tau.coef <- fun(tau, na.rm = TRUE)
    n0 <- fun(nu.0 * is.finite(nu.0), na.rm = TRUE)
    n1 <- fun(nu.1 * is.finite(nu.1), na.rm = TRUE)
    d.avg <- (d0 + d1) / 2
    z.avg <- (z0 + z1) / 2
    n.avg <- (n0 + n1) / 2

    if (!is.null(model.y$family)) {
      if (model.y$family$link == "logit") {
        ORet1 <- OR[, , 1] # joint mediated effect ORdelta(1)
        ORet2 <- OR[, , 2] # joint mediated effect ORdelta(0)
        ORet3  <- OR[, , 3] # direct effect ORzeta(1)
        ORet4  <- OR[, , 4] # direct effect ORzeta(0)
        ORdelta.1 <- t(as.matrix(apply(ORet1, 2, mean, na.rm = TRUE)))
        ORdelta.0 <- t(as.matrix(apply(ORet2, 2, mean, na.rm = TRUE)))
        ORzeta.1 <- t(as.matrix(apply(ORet3, 2, mean, na.rm = TRUE)))
        ORzeta.0 <- t(as.matrix(apply(ORet4, 2, mean, na.rm = TRUE)))



        ORtau <- (ORzeta.1 * ORdelta.0 + ORzeta.0 * ORdelta.1) / 2

        ORtau <- (ORzeta.1 * ORdelta.0 + ORzeta.0 * ORdelta.1) / 2
        ORnu.1 <- ORzeta.0 * (ORdelta.1 - 1) / (ORzeta.0 * ORdelta.1 - 1)
        ORnu.0 <- ORzeta.1 * (ORdelta.0 - 1) / (ORzeta.1 * ORdelta.0 - 1)

        ORtau.coef <- fun(ORtau, na.rm = TRUE)

        ORdelta.avg <- (ORdelta.1 + ORdelta.0) / 2
        ORnu.avg <- (ORnu.1 + ORnu.0) / 2
        ORzeta.avg <- (ORzeta.1 + ORzeta.0) / 2

        ORd1 <- fun(ORdelta.1 * is.finite(ORdelta.1), na.rm = TRUE)
        ORn1 <- fun(ORnu.1 * is.finite(ORnu.1), na.rm = TRUE)
        ORd0 <- fun(ORdelta.0 * is.finite(ORdelta.0), na.rm = TRUE)
        ORn0 <- fun(ORnu.0 * is.finite(ORnu.0), na.rm = TRUE)
        ORz1 <- fun(ORzeta.1 * is.finite(ORzeta.1), na.rm = TRUE)
        ORz0 <- fun(ORzeta.0 * is.finite(ORzeta.0), na.rm = TRUE)

        ORd.avg <- (ORd0 + ORd1) / 2
        ORz.avg <- (ORz0 + ORz1) / 2
        ORn.avg <- (ORn0 + ORn1) / 2

        logORdelta.1 <- log(ORdelta.1)
        logORtau <- log(ORtau)
        logORnu.1 <- logORdelta.1 / logORtau
        logORdelta.0 <- log(ORdelta.0)
        logORnu.0 <- logORdelta.0 / logORtau
        logORzeta.1 <- log(ORzeta.1)
        logORzeta.0 <- log(ORzeta.0)

        logORtau.coef <- fun(logORtau * is.finite(logORtau), na.rm = TRUE)
        logORnu.avg <- (logORnu.1 + logORnu.0) / 2
        logORn0 <- fun(logORnu.0 * is.finite(logORnu.0), na.rm = TRUE)
        logORn1 <- fun(logORnu.1 * is.finite(logORnu.1), na.rm = TRUE)
        logORn.avg <- (logORn0 + logORn1) / 2

        logORdelta.avg <- (logORdelta.1 + logORdelta.0) / 2
        logORzeta.avg <- (logORzeta.1 + logORzeta.0) / 2
        logORd0 <- fun(logORdelta.0 * is.finite(logORdelta.0), na.rm = TRUE)
        logORd1 <- fun(logORdelta.1 * is.finite(logORdelta.1), na.rm = TRUE)
        logORz1 <- fun(logORzeta.1 * is.finite(logORzeta.1), na.rm = TRUE)
        logORz0 <- fun(logORzeta.0 * is.finite(logORzeta.0), na.rm = TRUE)
        logORtau.coef <- fun(logORtau * is.finite(logORtau), na.rm = TRUE)
        logORd.avg <- (logORd0 + logORd1) / 2
        logORz.avg <- (logORz0 + logORz1) / 2

      }
    }

    if (NM != 1) {
      et5 <- effect.tmp.NM[, , 1, ]
      et6 <- effect.tmp.NM[, , 2, ]

      delta.1.NM <- t((apply(et5, c(2, 3), mean)))
      eta.1.NM <- array(delta.1, dim = c(NM, J)) - delta.1.NM
      delta.0.NM <- t(as.matrix(apply(et6, c(2, 3), mean)))
      eta.0.NM <- array(delta.0, dim = c(NM, J)) - delta.0.NM

      nu.0.NM <- delta.0.NM / array(tau, dim = c(NM, J))
      nu.1.NM <- delta.1.NM / array(tau, dim = c(NM, J))
      delta.avg.NM <- (delta.1.NM + delta.0.NM) / 2
      nu.avg.NM <- (nu.1.NM + nu.0.NM) / 2
      d0.NM <- apply(delta.0.NM * is.finite(delta.0.NM), 1, fun, na.rm = TRUE)
      d1.NM <- apply(delta.1.NM * is.finite(delta.1.NM), 1, fun, na.rm = TRUE)
      n0.NM <- apply(nu.0.NM * is.finite(nu.0.NM), 1, fun, na.rm = TRUE)
      n1.NM <- apply(nu.1.NM * is.finite(nu.1.NM), 1, fun, na.rm = TRUE)
      d.avg.NM <- (d0.NM + d1.NM) / 2
      n.avg.NM <- (n0.NM + n1.NM) / 2

      if (!is.null(model.y$family)) {
        if (model.y$family$link == "logit") {
          ORet5 <- OR.NM[, , 1, ]
          ORet6 <- OR.NM[, , 2, ]
          ORdelta.1.NM <- t((apply(ORet5, c(2, 3), mean)))
          OReta.1.NM <- array(ORdelta.1, dim = c(NM, J)) / ORdelta.1.NM
          ORdelta.0.NM <- t(as.matrix(apply(ORet6, c(2, 3), mean)))
          OReta.0.NM <- array(ORdelta.0, dim = c(NM, J)) / ORdelta.0.NM

          ORnu.0.NM <- array(ORzeta.1, dim = c(NM, J)) * OReta.0.NM * (ORdelta.0.NM -
                                                                         1) / (array(ORzeta.1 * ORdelta.0, dim = c(NM, J)) - 1)
          ORnu.1.NM <- array(ORzeta.0, dim = c(NM, J)) * OReta.1.NM * (ORdelta.1.NM -
                                                                         1) / (array(ORzeta.0 * ORdelta.1, dim = c(NM, J)) - 1)
          ORdelta.avg.NM <- (ORdelta.1.NM + ORdelta.0.NM) / 2
          ORnu.avg.NM <- (ORnu.1.NM + ORnu.0.NM) / 2
          ORd0.NM <- apply(ORdelta.0.NM * is.finite(ORdelta.0.NM),
                           1,
                           fun,
                           na.rm = TRUE)
          ORd1.NM <- apply(ORdelta.1.NM * is.finite(ORdelta.1.NM),
                           1,
                           fun,
                           na.rm = TRUE)
          ORn0.NM <- apply(ORnu.0.NM * is.finite(ORnu.0.NM), 1, fun, na.rm =
                             TRUE)
          ORn1.NM <- apply(ORnu.1.NM * is.finite(ORnu.1.NM), 1, fun, na.rm =
                             TRUE)
          ORd.avg.NM <- (ORd0.NM + ORd1.NM) / 2
          ORn.avg.NM <- (ORn0.NM + ORn1.NM) / 2

          logORdelta.1.NM <- log(ORdelta.1.NM)
          logORdelta.0.NM <- log(ORdelta.0.NM)
          logORnu.0.NM <- logORdelta.0.NM / array(logORtau, dim = c(NM, J))
          logORnu.1.NM <- logORdelta.1.NM / array(logORtau, dim = c(NM, J))

          logORnu.avg.NM <- (logORnu.1.NM + logORnu.0.NM) / 2
          logORn0.NM <- apply(logORdelta.0.NM / logORtau.coef, 1, fun, na.rm =
                                TRUE)
          logORn1.NM <- apply(logORdelta.1.NM / logORtau.coef, 1, fun, na.rm =
                                TRUE)
          logORn.avg.NM <- (logORn0.NM + logORn1.NM) / 2

          logORdelta.avg.NM <- (logORdelta.1.NM + logORdelta.0.NM) / 2
          logORd0.NM <- apply(logORdelta.0.NM, 1, fun, na.rm = TRUE)
          logORd1.NM <- apply(logORdelta.1.NM, 1, fun, na.rm = TRUE)
          logORd.avg.NM <- (logORd0.NM + logORd1.NM) / 2
        }
      }

    }
    else {
      delta.1.NM <- delta.0.NM <- NULL
      if (!is.null(model.y$family)) {
        if (model.y$family$link == "logit") {
          ORdelta.1.NM <- ORdelta.0.NM <- logORdelta.1.NM <- logORdelta.0.NM <- NULL
        }
      }
    }


    low <- (1 - conf.level) / 2
    high <- 1 - low

    d0.ci <- quantile(delta.0, c(low, high), na.rm = TRUE)
    d1.ci <- quantile(delta.1, c(low, high), na.rm = TRUE)
    tau.ci <- quantile(tau, c(low, high), na.rm = TRUE)
    z1.ci <- quantile(zeta.1, c(low, high), na.rm = TRUE)
    z0.ci <- quantile(zeta.0, c(low, high), na.rm = TRUE)
    n0.ci <- quantile(nu.0, c(low, high), na.rm = TRUE)
    n1.ci <- quantile(nu.1, c(low, high), na.rm = TRUE)
    d.avg.ci <- quantile(delta.avg, c(low, high), na.rm = TRUE)
    z.avg.ci <- quantile(zeta.avg, c(low, high), na.rm = TRUE)
    n.avg.ci <- quantile(nu.avg, c(low, high), na.rm = TRUE)

    d0.p <- pval(delta.0, d0)
    d1.p <- pval(delta.1, d1)
    d.avg.p <- pval(delta.avg, d.avg)
    z0.p <- pval(zeta.0, z0)
    z1.p <- pval(zeta.1, z1)
    z.avg.p <- pval(zeta.avg, z.avg)
    n0.p <- pval(nu.0, n0)
    n1.p <- pval(nu.1, n1)
    n.avg.p <- pval(nu.avg, n.avg)
    tau.p <- pval(tau, tau.coef)

    if (!is.null(model.y$family)) {
      if (model.y$family$link == "logit") {
        ORd0.ci <- quantile(ORdelta.0, c(low, high), na.rm = TRUE)
        ORd1.ci <- quantile(ORdelta.1, c(low, high), na.rm = TRUE)
        ORtau.ci <- quantile(ORtau, c(low, high), na.rm = TRUE)
        ORz1.ci <- quantile(ORzeta.1, c(low, high), na.rm = TRUE)
        ORz0.ci <- quantile(ORzeta.0, c(low, high), na.rm = TRUE)
        ORn0.ci <- quantile(ORnu.0, c(low, high), na.rm = TRUE)
        ORn1.ci <- quantile(ORnu.1, c(low, high), na.rm = TRUE)

        ORd.avg.ci <- quantile(ORdelta.avg, c(low, high), na.rm = TRUE)
        ORz.avg.ci <- quantile(ORzeta.avg, c(low, high), na.rm = TRUE)
        ORn.avg.ci <- quantile(ORnu.avg, c(low, high), na.rm = TRUE)

        ORd0.p <- pval(ORdelta.0, ORd0, seu = 1)
        ORd1.p <- pval(ORdelta.1, ORd1, seu = 1)
        ORd.avg.p <- pval(ORdelta.avg, ORd.avg, seu = 1)
        ORz0.p <- pval(ORzeta.0, ORz0, seu = 1)
        ORz1.p <- pval(ORzeta.1, ORz1, seu = 1)
        ORz.avg.p <- pval(ORzeta.avg, ORz.avg, seu = 1)
        ORn0.p <- pval(ORnu.0, ORn0)
        ORn1.p <- pval(ORnu.1, ORn1)
        ORn.avg.p <- pval(ORnu.avg, ORn.avg)
        ORtau.p <- pval(ORtau, ORtau.coef, seu = 1)

        logORn0.ci <- quantile(logORnu.0, c(low, high), na.rm = TRUE)
        logORn1.ci <- quantile(logORnu.1, c(low, high), na.rm = TRUE)
        logORn.avg.ci <- quantile(logORnu.avg, c(low, high), na.rm = TRUE)
        logORn0.p <- pval(logORnu.0, logORn0)
        logORn1.p <- pval(logORnu.1, logORn1)
        logORn.avg.p <- pval(logORnu.avg, logORn.avg)
        logORd0.ci <- quantile(logORdelta.0, c(low, high), na.rm = TRUE)
        logORd1.ci <- quantile(logORdelta.1, c(low, high), na.rm = TRUE)
        logORtau.ci <- quantile(logORtau, c(low, high), na.rm = TRUE)
        logORz1.ci <- quantile(logORzeta.1, c(low, high), na.rm = TRUE)
        logORz0.ci <- quantile(logORzeta.0, c(low, high), na.rm = TRUE)
        logORd.avg.ci <- quantile(logORdelta.avg, c(low, high), na.rm = TRUE)
        logORz.avg.ci <- quantile(logORzeta.avg, c(low, high), na.rm = TRUE)

        logORd0.p <- pval(logORdelta.0, logORd0)
        logORd1.p <- pval(logORdelta.1, logORd1)
        logORd.avg.p <- pval(logORdelta.avg, logORd.avg)
        logORz0.p <- pval(logORzeta.0, logORz0)
        logORz1.p <- pval(logORzeta.1, logORz1)
        logORz.avg.p <- pval(logORzeta.avg, logORz.avg)
        logORtau.p <- pval(logORtau, logORtau.coef)
      }
    }


    if (NM != 1) {
      d0.ci.NM <- d1.ci.NM <- n0.ci.NM <- n1.ci.NM <- d.avg.ci.NM <- n.avg.ci.NM <- array(NA, dim =
                                                                                            c(NM, 2))
      d0.p.NM <- d1.p.NM <- d.avg.p.NM <- n0.p.NM <- n1.p.NM <- n.avg.p.NM <- rep(NA, NM)
      for (nm in 1:NM) {
        d0.ci.NM[nm, ] <- quantile(delta.0.NM[nm, ], c(low, high), na.rm = TRUE)
        d1.ci.NM[nm, ] <- quantile(delta.1.NM[nm, ], c(low, high), na.rm = TRUE)
        n0.ci.NM[nm, ] <- quantile(nu.0.NM[nm, ], c(low, high), na.rm = TRUE)
        n1.ci.NM[nm, ] <- quantile(nu.1.NM[nm, ], c(low, high), na.rm = TRUE)
        d.avg.ci.NM[nm, ] <- quantile(delta.avg.NM[nm, ], c(low, high), na.rm = TRUE)
        n.avg.ci.NM[nm, ] <- quantile(nu.avg.NM[nm, ], c(low, high), na.rm = TRUE)

        d0.p.NM[nm] <- pval(delta.0.NM[nm, ], d0.NM[nm])
        d1.p.NM[nm] <- pval(delta.1.NM[nm, ], d1.NM[nm])
        d.avg.p.NM[nm] <- pval(delta.avg.NM[nm, ], d.avg.NM[nm])
        n0.p.NM[nm] <- pval(nu.0.NM[nm, ], n0.NM[nm])
        n1.p.NM[nm] <- pval(nu.1.NM[nm, ], n1.NM[nm])
        n.avg.p.NM[nm] <- pval(nu.avg.NM[nm, ], n.avg.NM[nm])
      }

      if (!is.null(model.y$family)) {
        if (model.y$family$link == "logit") {
          ORd0.ci.NM <- ORd1.ci.NM <- ORn0.ci.NM <- ORn1.ci.NM <- ORd.avg.ci.NM <- ORn.avg.ci.NM <- array(NA, dim =
                                                                                                            c(NM, 2))
          ORd0.p.NM <- ORd1.p.NM <- ORd.avg.p.NM <- ORn0.p.NM <- ORn1.p.NM <- ORn.avg.p.NM <- rep(NA, NM)

          logORd0.ci.NM <- logORd1.ci.NM <- logORn0.ci.NM <- logORn1.ci.NM <- logORd.avg.ci.NM <- logORn.avg.ci.NM <- array(NA, dim =
                                                                                                                              c(NM, 2))
          logORd0.p.NM <- logORd1.p.NM <- logORd.avg.p.NM <- logORn0.p.NM <- logORn1.p.NM <- logORn.avg.p.NM <- rep(NA, NM)
          for (nm in 1:NM) {
            ORd0.ci.NM[nm, ] <- quantile(ORdelta.0.NM[nm, ], c(low, high), na.rm = TRUE)
            ORd1.ci.NM[nm, ] <- quantile(ORdelta.1.NM[nm, ], c(low, high), na.rm = TRUE)
            ORn0.ci.NM[nm, ] <- quantile(ORnu.0.NM[nm, ], c(low, high), na.rm = TRUE)
            ORn1.ci.NM[nm, ] <- quantile(ORnu.1.NM[nm, ], c(low, high), na.rm = TRUE)
            ORd.avg.ci.NM[nm, ] <- quantile(ORdelta.avg.NM[nm, ], c(low, high), na.rm = TRUE)
            ORn.avg.ci.NM[nm, ] <- quantile(ORnu.avg.NM[nm, ], c(low, high), na.rm = TRUE)

            ORd0.p.NM[nm] <- pval(ORdelta.0.NM[nm, ], ORd0.NM[nm], seu = 1)
            ORd1.p.NM[nm] <- pval(ORdelta.1.NM[nm, ], ORd1.NM[nm], seu = 1)
            ORd.avg.p.NM[nm] <- pval(ORdelta.avg.NM[nm, ], ORd.avg.NM[nm], seu =
                                       1)
            ORn0.p.NM[nm] <- pval(ORnu.0.NM[nm, ], ORn0.NM[nm])
            ORn1.p.NM[nm] <- pval(ORnu.1.NM[nm, ], ORn1.NM[nm])
            ORn.avg.p.NM[nm] <- pval(ORnu.avg.NM[nm, ], ORn.avg.NM[nm])

            logORd0.ci.NM[nm, ] <- quantile(logORdelta.0.NM[nm, ], c(low, high), na.rm = TRUE)
            logORd1.ci.NM[nm, ] <- quantile(logORdelta.1.NM[nm, ], c(low, high), na.rm = TRUE)
            logORd.avg.ci.NM[nm, ] <- quantile(logORdelta.avg.NM[nm, ], c(low, high), na.rm = TRUE)
            logORn0.ci.NM[nm, ] <- quantile(logORnu.0.NM[nm, ], c(low, high), na.rm = TRUE)
            logORn1.ci.NM[nm, ] <- quantile(logORnu.1.NM[nm, ], c(low, high), na.rm = TRUE)
            logORn.avg.ci.NM[nm, ] <- quantile(logORnu.avg.NM[nm, ], c(low, high), na.rm = TRUE)
            logORd0.p.NM[nm] <- pval(logORdelta.0.NM[nm, ], logORd0.NM[nm])
            logORd1.p.NM[nm] <- pval(logORdelta.1.NM[nm, ], logORd1.NM[nm])
            logORd.avg.p.NM[nm] <- pval(logORdelta.avg.NM[nm, ], logORd.avg.NM[nm])
            logORn0.p.NM[nm] <- pval(logORnu.0.NM[nm, ], logORn0.NM[nm])
            logORn1.p.NM[nm] <- pval(logORnu.1.NM[nm, ], logORn1.NM[nm])
            logORn.avg.p.NM[nm] <- pval(logORnu.avg.NM[nm, ], logORn.avg.NM[nm])
          }


        }
      }
    }
    if (NM == 1) {
      out <- list(
        d0 = d0,
        d1 = d1,
        d0.ci = d0.ci,
        d1.ci = d1.ci,
        d0.p = d0.p,
        d1.p = d1.p,
        d0.sims = delta.0,
        d1.sims = delta.1,
        z0 = z0,
        z1 = z1,
        z0.ci = z0.ci,
        z1.ci = z1.ci,
        z0.p = z0.p,
        z1.p = z1.p,
        z0.sims = zeta.0,
        z1.sims = zeta.1,
        n0 = n0,
        n1 = n1,
        n0.ci = n0.ci,
        n1.ci = n1.ci,
        n0.p = n0.p,
        n1.p = n1.p,
        n0.sims = nu.0,
        n1.sims = nu.1,
        tau.coef = tau.coef,
        tau.ci = tau.ci,
        tau.p = tau.p,
        tau.sims = tau,
        d.avg = d.avg,
        d.avg.p = d.avg.p,
        d.avg.ci = d.avg.ci,
        d.avg.sims = delta.avg,
        z.avg = z.avg,
        z.avg.p = z.avg.p,
        z.avg.ci = z.avg.ci,
        z.avg.sims = zeta.avg,
        n.avg = n.avg,
        n.avg.p = n.avg.p,
        n.avg.ci = n.avg.ci,
        n.avg.sims = nu.avg,
        treat = treat,
        mediator = mediator,
        conf.level = conf.level,
        model.y = model.y,
        model.m = lmodel.m,
        control.value = control.value,
        treat.value = treat.value,
        nobs = N,
        sims = J,
        cov = cov,
        cor = cor
      )
      if (!is.null(model.y$family)) {
        if (model.y$family$link == "logit") {
          out <- list(
            d0 = d0,
            d1 = d1,
            d0.ci = d0.ci,
            d1.ci = d1.ci,
            d0.p = d0.p,
            d1.p = d1.p,
            d0.sims = delta.0,
            d1.sims = delta.1,
            z0 = z0,
            z1 = z1,
            z0.ci = z0.ci,
            z1.ci = z1.ci,
            z0.p = z0.p,
            z1.p = z1.p,
            z0.sims = zeta.0,
            z1.sims = zeta.1,
            n0 = n0,
            n1 = n1,
            n0.ci = n0.ci,
            n1.ci = n1.ci,
            n0.p = n0.p,
            n1.p = n1.p,
            n0.sims = nu.0,
            n1.sims = nu.1,
            tau.coef = tau.coef,
            tau.ci = tau.ci,
            tau.p = tau.p,
            tau.sims = tau,
            d.avg = d.avg,
            d.avg.p = d.avg.p,
            d.avg.ci = d.avg.ci,
            d.avg.sims = delta.avg,
            z.avg = z.avg,
            z.avg.p = z.avg.p,
            z.avg.ci = z.avg.ci,
            z.avg.sims = zeta.avg,
            n.avg = n.avg,
            n.avg.p = n.avg.p,
            n.avg.ci = n.avg.ci,
            n.avg.sims = nu.avg,
            treat = treat,
            mediator = mediator,
            conf.level = conf.level,
            model.y = model.y,
            model.m = lmodel.m,
            control.value = control.value,
            treat.value = treat.value,
            nobs = N,
            sims = J,
            cov = cov,
            cor = cor,
            ORd0 = ORd0,
            ORd1 = ORd1,
            ORd0.ci = ORd0.ci,
            ORd1.ci = ORd1.ci,
            ORd0.p = ORd0.p,
            ORd1.p = ORd1.p,
            ORd0.sims = ORdelta.0,
            ORd1.sims = ORdelta.1,
            ORz0 = ORz0,
            ORz1 = ORz1,
            ORz0.ci = ORz0.ci,
            ORz1.ci = ORz1.ci,
            ORz0.p = ORz0.p,
            ORz1.p = ORz1.p,
            ORz0.sims = ORzeta.0,
            ORz1.sims = ORzeta.1,
            ORn0 = ORn0,
            ORn1 = ORn1,
            ORn0.ci = ORn0.ci,
            ORn1.ci = ORn1.ci,
            ORn0.p = ORn0.p,
            ORn1.p = ORn1.p,
            ORn0.sims = ORnu.0,
            ORn1.sims = ORnu.1,
            ORtau.coef = ORtau.coef,
            ORtau.ci = ORtau.ci,
            ORtau.p = ORtau.p,
            ORtau.sims = ORtau,
            ORd.avg = ORd.avg,
            ORd.avg.p = ORd.avg.p,
            ORd.avg.ci = ORd.avg.ci,
            ORd.avg.sims = ORdelta.avg,
            ORz.avg = ORz.avg,
            ORz.avg.p = ORz.avg.p,
            ORz.avg.ci = ORz.avg.ci,
            ORz.avg.sims = ORzeta.avg,
            ORn.avg = ORn.avg,
            ORn.avg.p = ORn.avg.p,
            ORn.avg.ci = ORn.avg.ci,
            ORn.avg.sims = ORnu.avg,
            logORd0 = logORd0,
            logORd1 = logORd1,
            logORd0.ci = logORd0.ci,
            logORd1.ci = logORd1.ci,
            logORd0.p = logORd0.p,
            logORd1.p = logORd1.p,
            logORd0.sims = logORdelta.0,
            logORd1.sims = logORdelta.1,
            logORz0 = logORz0,
            logORz1 = logORz1,
            logORz0.ci = logORz0.ci,
            logORz1.ci = logORz1.ci,
            logORz0.p = logORz0.p,
            logORz1.p = logORz1.p,
            logORz0.sims = logORzeta.0,
            logORz1.sims = logORzeta.1,
            logORn0 = logORn0,
            logORn1 = logORn1,
            logORn0.ci = logORn0.ci,
            logORn1.ci = logORn1.ci,
            logORn0.p = logORn0.p,
            logORn1.p = logORn1.p,
            logORn0.sims = logORnu.0,
            logORn1.sims = logORnu.1,
            logORtau.coef = logORtau.coef,
            logORtau.ci = logORtau.ci,
            logORtau.p = logORtau.p,
            logORtau.sims = logORtau,
            logORd.avg = logORd.avg,
            logORd.avg.p = logORd.avg.p,
            logORd.avg.ci = logORd.avg.ci,
            logORd.avg.sims = logORdelta.avg,
            logORz.avg = logORz.avg,
            logORz.avg.p = logORz.avg.p,
            logORz.avg.ci = logORz.avg.ci,
            logORz.avg.sims = logORzeta.avg,
            logORn.avg = logORn.avg,
            logORn.avg.p = logORn.avg.p,
            logORn.avg.ci = logORn.avg.ci,
            logORn.avg.sims = logORnu.avg
          )
        }
      }
    }
    else {
      out <- list(
        d0 = d0,
        d1 = d1,
        d0.ci = d0.ci,
        d1.ci = d1.ci,
        d0.p = d0.p,
        d1.p = d1.p,
        d0.sims = delta.0,
        d1.sims = delta.1,
        d0.NM = d0.NM,
        d1.NM = d1.NM,
        d0.ci.NM = d0.ci.NM,
        d1.ci.NM = d1.ci.NM,
        d0.p.NM = d0.p.NM,
        d1.p.NM = d1.p.NM,
        d0.sims.NM = delta.0.NM,
        d1.sims.NM = delta.1.NM,
        z0 = z0,
        z1 = z1,
        z0.ci = z0.ci,
        z1.ci = z1.ci,
        z0.p = z0.p,
        z1.p = z1.p,
        z0.sims = zeta.0,
        z1.sims = zeta.1,
        n0 = n0,
        n1 = n1,
        n0.ci = n0.ci,
        n1.ci = n1.ci,
        n0.p = n0.p,
        n1.p = n1.p,
        n0.sims = nu.0,
        n1.sims = nu.1,
        n0.NM = n0.NM,
        n1.NM = n1.NM,
        n0.ci.NM = n0.ci.NM,
        n1.ci.NM = n1.ci.NM,
        n0.p.NM = n0.p.NM,
        n1.p.NM = n1.p.NM,
        n0.sims.NM = nu.0.NM,
        n1.sims.NM = nu.1.NM,
        tau.coef = tau.coef,
        tau.ci = tau.ci,
        tau.p = tau.p,
        tau.sims = tau,
        d.avg = d.avg,
        d.avg.p = d.avg.p,
        d.avg.ci = d.avg.ci,
        d.avg.sims = delta.avg,
        d.avg.NM = d.avg.NM,
        d.avg.p.NM = d.avg.p.NM,
        d.avg.ci.NM = d.avg.ci.NM,
        d.avg.sims.NM = delta.avg.NM,
        z.avg = z.avg,
        z.avg.p = z.avg.p,
        z.avg.ci = z.avg.ci,
        z.avg.sims = zeta.avg,
        n.avg = n.avg,
        n.avg.p = n.avg.p,
        n.avg.ci = n.avg.ci,
        n.avg.sims = nu.avg,
        n.avg.NM = n.avg.NM,
        n.avg.p.NM = n.avg.p.NM,
        n.avg.ci.NM = n.avg.ci.NM,
        n.avg.sims.NM = nu.avg.NM,
        treat = treat,
        mediator = mediator,
        conf.level = conf.level,
        model.y = model.y,
        model.m = lmodel.m,
        control.value = control.value,
        treat.value = treat.value,
        nobs = N,
        sims = J,
        cov = cov,
        cor = cor
      )

      if (!is.null(model.y$family)) {
        if (model.y$family$link == "logit") {
          out <- list(
            d0 = d0,
            d1 = d1,
            d0.ci = d0.ci,
            d1.ci = d1.ci,
            d0.p = d0.p,
            d1.p = d1.p,
            d0.sims = delta.0,
            d1.sims = delta.1,
            d0.NM = d0.NM,
            d1.NM = d1.NM,
            d0.ci.NM = d0.ci.NM,
            d1.ci.NM = d1.ci.NM,
            d0.p.NM = d0.p.NM,
            d1.p.NM = d1.p.NM,
            d0.sims.NM = delta.0.NM,
            d1.sims.NM = delta.1.NM,
            z0 = z0,
            z1 = z1,
            z0.ci = z0.ci,
            z1.ci = z1.ci,
            z0.p = z0.p,
            z1.p = z1.p,
            z0.sims = zeta.0,
            z1.sims = zeta.1,
            n0 = n0,
            n1 = n1,
            n0.ci = n0.ci,
            n1.ci = n1.ci,
            n0.p = n0.p,
            n1.p = n1.p,
            n0.sims = nu.0,
            n1.sims = nu.1,
            n0.NM = n0.NM,
            n1.NM = n1.NM,
            n0.ci.NM = n0.ci.NM,
            n1.ci.NM = n1.ci.NM,
            n0.p.NM = n0.p.NM,
            n1.p.NM = n1.p.NM,
            n0.sims.NM = nu.0.NM,
            n1.sims.NM = nu.1.NM,
            tau.coef = tau.coef,
            tau.ci = tau.ci,
            tau.p = tau.p,
            tau.sims = tau,
            d.avg = d.avg,
            d.avg.p = d.avg.p,
            d.avg.ci = d.avg.ci,
            d.avg.sims = delta.avg,
            d.avg.NM = d.avg.NM,
            d.avg.p.NM = d.avg.p.NM,
            d.avg.ci.NM = d.avg.ci.NM,
            d.avg.sims.NM = delta.avg.NM,
            z.avg = z.avg,
            z.avg.p = z.avg.p,
            z.avg.ci = z.avg.ci,
            z.avg.sims = zeta.avg,
            n.avg = n.avg,
            n.avg.p = n.avg.p,
            n.avg.ci = n.avg.ci,
            n.avg.sims = nu.avg,
            n.avg.NM = n.avg.NM,
            n.avg.p.NM = n.avg.p.NM,
            n.avg.ci.NM = n.avg.ci.NM,
            n.avg.sims.NM = nu.avg.NM,
            treat = treat,
            mediator = mediator,
            conf.level = conf.level,
            model.y = model.y,
            model.m = lmodel.m,
            control.value = control.value,
            treat.value = treat.value,
            nobs = N,
            sims = J,
            cov = cov,
            cor = cor,
            ORd0 = ORd0,
            ORd1 = ORd1,
            ORd0.ci = ORd0.ci,
            ORd1.ci = ORd1.ci,
            ORd0.p = ORd0.p,
            ORd1.p = ORd1.p,
            ORd0.sims = ORdelta.0,
            ORd1.sims = ORdelta.1,
            ORd0.NM = ORd0.NM,
            ORd1.NM = ORd1.NM,
            ORd0.ci.NM = ORd0.ci.NM,
            ORd1.ci.NM = ORd1.ci.NM,
            ORd0.p.NM = ORd0.p.NM,
            ORd1.p.NM = ORd1.p.NM,
            ORd0.sims.NM = ORdelta.0.NM,
            ORd1.sims.NM = ORdelta.1.NM,
            ORz0 = ORz0,
            ORz1 = ORz1,
            ORz0.ci = ORz0.ci,
            ORz1.ci = ORz1.ci,
            ORz0.p = ORz0.p,
            ORz1.p = ORz1.p,
            ORz0.sims = ORzeta.0,
            ORz1.sims = ORzeta.1,
            ORn0 = ORn0,
            ORn1 = ORn1,
            ORn0.ci = ORn0.ci,
            ORn1.ci = ORn1.ci,
            ORn0.p = ORn0.p,
            ORn1.p = ORn1.p,
            ORn0.sims = ORnu.0,
            ORn1.sims = ORnu.1,
            ORn0.NM = ORn0.NM,
            ORn1.NM = ORn1.NM,
            ORn0.ci.NM = ORn0.ci.NM,
            ORn1.ci.NM = ORn1.ci.NM,
            ORn0.p.NM = ORn0.p.NM,
            ORn1.p.NM = ORn1.p.NM,
            ORn0.sims.NM = ORnu.0.NM,
            ORn1.sims.NM = ORnu.1.NM,
            ORtau.coef = ORtau.coef,
            ORtau.ci = ORtau.ci,
            ORtau.p = ORtau.p,
            ORtau.sims = ORtau,
            ORd.avg = ORd.avg,
            ORd.avg.p = ORd.avg.p,
            ORd.avg.ci = ORd.avg.ci,
            ORd.avg.sims = ORdelta.avg,
            ORd.avg.NM = ORd.avg.NM,
            ORd.avg.p.NM = ORd.avg.p.NM,
            ORd.avg.ci.NM = ORd.avg.ci.NM,
            ORd.avg.sims.NM = ORdelta.avg.NM,
            ORz.avg = ORz.avg,
            ORz.avg.p = ORz.avg.p,
            ORz.avg.ci = ORz.avg.ci,
            ORz.avg.sims = ORzeta.avg,
            ORn.avg = ORn.avg,
            ORn.avg.p = ORn.avg.p,
            ORn.avg.ci = ORn.avg.ci,
            ORn.avg.sims = ORnu.avg,
            ORn.avg.NM = ORn.avg.NM,
            ORn.avg.p.NM = ORn.avg.p.NM,
            ORn.avg.ci.NM = ORn.avg.ci.NM,
            ORn.avg.sims.NM = ORnu.avg.NM,
            logORd0 = logORd0,
            logORd1 = logORd1,
            logORd0.ci = logORd0.ci,
            logORd1.ci = logORd1.ci,
            logORd0.p = logORd0.p,
            logORd1.p = logORd1.p,
            logORd0.sims = logORdelta.0,
            logORd1.sims = logORdelta.1,
            logORd0.NM = logORd0.NM,
            logORd1.NM = logORd1.NM,
            logORd0.ci.NM = logORd0.ci.NM,
            logORd1.ci.NM = logORd1.ci.NM,
            logORd0.p.NM = logORd0.p.NM,
            logORd1.p.NM = logORd1.p.NM,
            logORd0.sims.NM = logORdelta.0.NM,
            logORd1.sims.NM = logORdelta.1.NM,
            logORz0 = logORz0,
            logORz1 = logORz1,
            logORz0.ci = logORz0.ci,
            logORz1.ci = logORz1.ci,
            logORz0.p = logORz0.p,
            logORz1.p = logORz1.p,
            logORz0.sims = logORzeta.0,
            logORz1.sims = logORzeta.1,
            logORn0 = logORn0,
            logORn1 = logORn1,
            logORn0.ci = logORn0.ci,
            logORn1.ci = logORn1.ci,
            logORn0.p = logORn0.p,
            logORn1.p = logORn1.p,
            logORn0.sims = logORnu.0,
            logORn1.sims = logORnu.1,
            logORn0.NM = logORn0.NM,
            logORn1.NM = logORn1.NM,
            logORn0.ci.NM = logORn0.ci.NM,
            logORn1.ci.NM = logORn1.ci.NM,
            logORn0.p.NM = logORn0.p.NM,
            logORn1.p.NM = logORn1.p.NM,
            logORn0.sims.NM = logORnu.0.NM,
            logORn1.sims.NM = logORnu.1.NM,
            logORtau.coef = logORtau.coef,
            logORtau.ci = logORtau.ci,
            logORtau.p = logORtau.p,
            logORtau.sims = logORtau,
            logORd.avg = logORd.avg,
            logORd.avg.p = logORd.avg.p,
            logORd.avg.ci = logORd.avg.ci,
            logORd.avg.sims = logORdelta.avg,
            logORd.avg.NM = logORd.avg.NM,
            logORd.avg.p.NM = logORd.avg.p.NM,
            logORd.avg.ci.NM = logORd.avg.ci.NM,
            logORd.avg.sims.NM = logORdelta.avg.NM,
            logORz.avg = logORz.avg,
            logORz.avg.p = logORz.avg.p,
            logORz.avg.ci = logORz.avg.ci,
            logORz.avg.sims = logORzeta.avg,
            logORn.avg = logORn.avg,
            logORn.avg.p = logORn.avg.p,
            logORn.avg.ci = logORn.avg.ci,
            logORn.avg.sims = logORnu.avg,
            logORn.avg.NM = logORn.avg.NM,
            logORn.avg.p.NM = logORn.avg.p.NM,
            logORn.avg.ci.NM = logORn.avg.ci.NM,
            logORn.avg.sims.NM = logORnu.avg.NM
          )
        }
      }
    }
    class(out) <- "mm"
    return(out)
  }
}

#' multimediate_survival - internal function
#'
#' @param lmodel.m A list of fitted mediator models (`lm`, `glm`, or `polr` objects).
#' @param correlated a logical value. if 'FALSE' a identity matrix is used for the matrix of correlation of mediators; if 'TRUE' matrix of correlation is estimated. Default is 'FALSE'.
#' @param model.y A fitted outcome model (`lm`, `glm`, `polr`, or `aalen` object).
#' @param treat The name of the treatment variable (character).
#' @param treat.value The value representing the treatment condition (default: 1).
#' @param control.value The value representing the control condition (default: 0).
#' @param J Number of Monte Carlo simulations for effect estimation (default: 1000).
#' @param conf.level Confidence level for confidence intervals (default: 0.95).
#' @param fun A summary function applied to the simulated effects (default: `mean`).
#' @param data A data frame containing the variables used in the models.
#' @param peryr Scaling factor for incidence rates per person-year (default: 100,000).
#' @param verbose Logical. If `TRUE` (default), messages and a progress bar are displayed during execution.
#'
#' @return A list containing estimated direct, indirect (mediated), and total effects,
#' along with confidence intervals and p-values for each.
#'
#'
#' @importFrom MASS mvrnorm
#' @importFrom mvtnorm rmvnorm
#' @importFrom utils txtProgressBar
#' @importFrom utils setTxtProgressBar
#' @importFrom timereg aalen
#' @importFrom utils tail
#'
#' @keywords internal




multimediate_survival=function(lmodel.m, correlated = FALSE, model.y, treat, treat.value = 1, control.value = 0, J = 1000,conf.level = 0.95, fun = mean, data = NULL, peryr = 100000, verbose = TRUE){

  N=dim(lmodel.m[[1]]$model)[1]
  NM=length(lmodel.m)

  for(nm in 1:NM){
    testmm=inherits(lmodel.m[[nm]], c("lm","glm","polr"))
    if(testmm==FALSE){
      stop("Mediator's model not implemented yet.")
    }

    if (!inherits(lmodel.m[[nm]],"lm")){
      for(c in 1:dim(lmodel.m[[nm]]$model)[2]){
        if(!is.factor(lmodel.m[[nm]]$model[,c])){
          stop("covariate ",names(lmodel.m[[nm]]$model)[c]," in mediators models must be discretize and/or factorize.")
        }
      }


    }
  }

  testy=inherits(model.y, c("lm","glm","polr","aalen"))
  if(testy==FALSE){
    stop("Outcome's model not implemented yet.")
  }

  mediator=c()
  MModel = list()
  for (nm in 1:NM){
    MModel[[nm]]=rmvnorm(J, mean = c(coef(lmodel.m[[nm]]),lmodel.m[[nm]]$zeta), sigma = vcov(lmodel.m[[nm]]))
    mediator=c(mediator,names(lmodel.m[[nm]]$model)[1])
  }

  if (correlated==TRUE){
    mcov=CorCond(e=10^(-10),lmodel.m)
    error=mvrnorm(n=N*J,mu=rep(0,NM),mcov$sigmaestim,tol=100)
    cov=mcov$sigmaestim
    cor=mcov$correstim
  } else{
    error=mvrnorm(n=N*J,mu=rep(0,NM),diag(rep(1,NM)))
    cov=diag(rep(1,NM))
  }

  if(inherits(model.y, "aalen")){
    YModel = rmvnorm(J, mean = model.y$gamma, sigma = model.y$robvar.gamma)
  } else {
    YModel = rmvnorm(J, mean = c(coef(model.y),model.y$zeta), sigma = vcov(model.y))
  }

  if(!inherits(model.y, "aalen")){
    if ( !is.null(model.y$family$link)){
      if (model.y$family$link=="logit"){
        Yerror <- rlogis(N,0,1)
      }
      else{
        Yerror <- rnorm(N,0,1)
      }
    }
    else {
      Yerror <- rnorm(N,0,1)
    }
  }

  PredictM1<-PredictM0<-PredictM1b<-PredictM0b<- array(0, dim=c(J,N,NM))

  if (isTRUE(verbose)) message("Simulation of counterfactuals mediators")
  if (isTRUE(verbose)) pb <- txtProgressBar(min = 0, max = NM, style = 3,title ="Simulation of counterfactuals mediators")
  for (nm in 1:NM){
    pred.data.t <- pred.data.c <- model.frame(lmodel.m[[nm]])

    if (is.factor(lmodel.m[[nm]]$model[,treat])) {
      pred.data.t[, treat] <- factor(treat.value, levels = levels(lmodel.m[[nm]]$model[, treat]))
      pred.data.c[, treat] <- factor(control.value,levels= levels(lmodel.m[[nm]]$model[, treat]))
    } else {
      pred.data.t[, treat] <- treat.value
      pred.data.c[, treat] <- control.value
    }


    if(inherits(lmodel.m[[nm]],"polr")){
      mmat.t <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.t)
      mmat.c <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.c)
      mmat.t=mmat.t[,-1]
      mmat.c=mmat.c[,-1]

      if (is.null(dim(mmat.t))){
        muM1 <- tcrossprod(MModel[[nm]][,1], mmat.t)
        muM0 <- tcrossprod(MModel[[nm]][,1], mmat.c)
      } else{
        muM1 <- tcrossprod(MModel[[nm]][,1:dim(mmat.t)[2]], mmat.t)
        muM0 <- tcrossprod(MModel[[nm]][,1:dim(mmat.t)[2]], mmat.c)
      }


      PredictM1[,,nm] <- array(muM1,dim=c(J,N)) + array(error[,nm], dim=c(J,N))
      PredictM0[,,nm] <- array(muM0,dim=c(J,N)) + array(error[,nm], dim=c(J,N))
      PredictM1b[,,nm] = array(muM1,dim=c(J,N)) + array(error[,nm], dim=c(J,N))
      PredictM0b[,,nm] = array(muM0,dim=c(J,N)) + array(error[,nm], dim=c(J,N))

      seuil=c(-Inf,lmodel.m[[nm]]$zeta,Inf)
      for (k in 1:length(lmodel.m[[nm]]$lev)){
        for (j in 1:J){
          a=which(PredictM1b[j,,nm]>seuil[k] & PredictM1b[j,,nm]<=seuil[k+1])
          b=which(PredictM0b[j,,nm]>seuil[k] & PredictM0b[j,,nm]<=seuil[k+1])
          PredictM1[j,a,nm]=lmodel.m[[nm]]$lev[k]
          PredictM0[j,b,nm]=lmodel.m[[nm]]$lev[k]
        }
      }
    } else{
      mmat.t <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.t)
      mmat.c <- model.matrix(terms(lmodel.m[[nm]]), data = pred.data.c)

      muM1 <- tcrossprod(MModel[[nm]], mmat.t)
      muM0 <- tcrossprod(MModel[[nm]], mmat.c)

      PredictM1[,,nm] <- array(muM1,dim=c(J,N)) + array(error[,nm], dim=c(J,N))
      PredictM0[,,nm] <- array(muM0,dim=c(J,N)) + array(error[,nm], dim=c(J,N))
      if (inherits(lmodel.m[[nm]],"glm")){
        PredictM1[,,nm]=(PredictM1[,,nm]>0)*1
        PredictM0[,,nm]=(PredictM0[,,nm]>0)*1
      }
    }
    if (isTRUE(verbose)) setTxtProgressBar(pb, nm)
  }
  if (isTRUE(verbose)) close(pb)

  effect.tmp.NM=OR.NM=array(NA, dim = c(N, J, 2, NM))
  effect.tmp=OR=array(NA, dim = c(N, J, 4))
  title=paste("Simulation of counterfactuals outcomes ",1:4,"/4",sep="")
  for (e in 1:4) {
    tt <- switch(e, c(1, 1, 1, 0), c(0, 0, 1, 0),
                 c(1, 0, 1, 1), c(1, 0, 0, 0))
    Pr0<-Pr1<-ORPr0<-ORPr1<- matrix(NA, nrow = N, ncol = J)
    if (NM!=1 & e<=2) {
      Pr0.NM<-Pr1.NM <-ORPr0.NM<-ORPr1.NM <- array(NA,dim=c(N,J,NM))
    }

    if (isTRUE(verbose)) message(title[e])
    if (isTRUE(verbose)) pb <- txtProgressBar(min = 0, max = J, style = 3,title=title[e])

    for (j in 1:J) {
      if(inherits(model.y, "aalen")){
        pred.data.t <- pred.data.c <- data[,getvarnames(model.y$call)$xvar]
      } else{
        pred.data.t <- pred.data.c <-model.frame(model.y)
      }

      cat.t <- ifelse(tt[1], treat.value, control.value)
      cat.c <- ifelse(tt[2], treat.value, control.value)

      if (is.factor(data[, treat])) {
        pred.data.t[, treat] <- factor(cat.t, levels = levels(data[, treat]))
        pred.data.c[, treat] <- factor(cat.c, levels = levels(data[, treat]))

      } else {
        pred.data.t[, treat] <- cat.t
        pred.data.c[, treat] <- cat.c
      }


      if (tt[3]==1){
        PredictMt=PredictM1[j,,]
      } else {
        PredictMt=PredictM0[j,,]
      }
      if (tt[4]==1){
        PredictMc=PredictM1[j,,]
      } else {
        PredictMc=PredictM0[j,,]
      }

      pred.data.t[, mediator] <- PredictMt
      pred.data.c[, mediator] <- PredictMc

      for (nm in 1:NM){
        if(inherits(lmodel.m[[nm]],"polr")){
          pred.data.c[,mediator[nm]]=as.factor(pred.data.c[,mediator[nm]])
          levels(pred.data.c[,mediator[nm]])=lmodel.m[[nm]]$lev
          pred.data.t[,mediator[nm]]=as.factor(pred.data.t[,mediator[nm]])
          levels(pred.data.t[,mediator[nm]])=lmodel.m[[nm]]$lev
        }

        if(inherits(lmodel.m[[nm]],"lm") & !inherits(lmodel.m[[nm]],"glm")){
          pred.data.c[,mediator[nm]]=as.numeric(pred.data.c[,mediator[nm]])
          pred.data.t[,mediator[nm]]=as.numeric(pred.data.t[,mediator[nm]])
        }

        if(inherits(lmodel.m[[nm]],"glm")){
          pred.data.c[,mediator[nm]]=as.factor(pred.data.c[,mediator[nm]])
          levels(pred.data.c[,mediator[nm]])=levels(lmodel.m[[nm]]$model[,1])
          pred.data.t[,mediator[nm]]=as.factor(pred.data.t[,mediator[nm]])
          levels(pred.data.t[,mediator[nm]])=levels(lmodel.m[[nm]]$model[,1])
        }
      }



      get_last_level <- function(data, cols) {
        sapply(cols, function(col) {
          x <- data[[col]]
          if (!is.factor(x) || length(levels(x)) == 0) {
            return(col)
          }
          last_lvl <- tail(levels(x), 1)
          paste0(col, last_lvl)
        }, USE.NAMES = FALSE)
      }

      get_levels_except_first <- function(data, cols) {
        unlist(lapply(cols, function(col) {
          x <- data[[col]]
          if (!is.factor(x) || length(levels(x)) <= 1) {
            return(col)
          }
          lvls <- levels(x)[-1]
          paste0(col, lvls)
        }))
      }

      if(inherits(model.y, "aalen")){
        trans.t <- model.matrix(~ ., data=data[,getvarnames(model.y$call)$xvar])[,-1]
        trans.t[, grep(treat,colnames(trans.t))] <- as.numeric(as.character(pred.data.t[, treat]))
        mediator_y <- get_levels_except_first(data, mediator)
        trans.t[, mediator_y] <- as.matrix(apply(pred.data.t[, mediator, drop = FALSE], 2, function(x) as.numeric(as.character(x))))

        trans.c <- model.matrix(~ ., data=data[,getvarnames(model.y$call)$xvar])[,-1]
        trans.c[, grep(treat,colnames(trans.c))] <- as.numeric(as.character(pred.data.c[, treat]))
        trans.c[, mediator_y] <- as.matrix(apply(pred.data.c[, mediator, drop = FALSE], 2, function(x) as.numeric(as.character(x))))

        ymat.t = trans.t
        ymat.c = trans.c

        if(length(grep(' * ', row.names(coef(model.y))))>0){
          ymat.t = as.data.frame(trans.t)
          ymat.c = as.data.frame(trans.c)
          position <- grep(' * ', row.names(coef(model.y)))
          count <- 0
          order <- unlist(strsplit(substr(row.names(coef(model.y)), 7, unlist(gregexpr(')', row.names(coef(model.y))))),')'))
          for(i in mediator){
            count <- count + 1
            if (grepl(i, row.names(coef(model.y))[position[count]])){
              med_int <- i
              order[position[count]] <- paste0('interaction_', count)
              ymat.t[,paste0('interaction_', count)] <- ymat.t[,treat]*ymat.t[,med_int]
              ymat.c[,paste0('interaction_', count)] <- ymat.c[,treat]*ymat.c[,med_int]
            }
          }
          ymat.t <- as.matrix(ymat.t[,pmatch(order, colnames(ymat.t))])
          ymat.c <- as.matrix(ymat.c[,pmatch(order, colnames(ymat.c))])
        }
      } else{

        ymat.t=ymat.c=model.matrix(model.y)
        trans.t <- model.matrix(terms(model.y), data = pred.data.t)
        trans.c <- model.matrix(terms(model.y), data = pred.data.c)

        ymat.t[,colnames(ymat.t) %in% colnames(trans.t)]=trans.t
        ymat.t[,!(colnames(ymat.t) %in% colnames(trans.t))]=0
        ymat.c[,colnames(ymat.c) %in% colnames(trans.c)]=trans.c
        ymat.c[,!(colnames(ymat.c) %in% colnames(trans.c))]=0

        if(!inherits(model.y,"polr") & length(grep(':', names(coef(model.y))))>0){
          ymat.t <- as.data.frame(ymat.t)
          ymat.c <- as.data.frame(ymat.c)
          position <- grep(':', names(coef(model.y)))
          for(i in mediator){
            if (grepl(i, names(coef(model.y))[position])){
              med_int <- i
            }
          }

        order <- names(coef(model.y))
        order[position] <- 'interaction'
        ymat.t$interaction <- ymat.t$Exposant*ymat.t[,med_int]
        ymat.t <- as.matrix(ymat.t[,order])
        ymat.c$interaction <- ymat.c$Exposant*ymat.c[,med_int]
        ymat.c <- as.matrix(ymat.c[,order])
        }
      }



      if (!inherits(model.y,"polr")){
        if(inherits(model.y, "aalen")){
          Pr1[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
          Pr0[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
        } else{
          Pr1[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t) + Yerror
          Pr0[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c) + Yerror
        }
        ORPr1[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
        ORPr0[,j] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
      } else{
        ymat.t=ymat.t[,-1]
        ymat.c=ymat.c[,-1]
        Pr1[,j] <- t(as.matrix(YModel[j,1:dim(ymat.t)[2]])) %*% t(ymat.t)+ Yerror
        Pr0[,j] <- t(as.matrix(YModel[j,1:dim(ymat.c)[2]])) %*% t(ymat.c)+ Yerror

        seuilY=c(-Inf,model.y$zeta,Inf)
        Pr1b=as.numeric(Pr1[,j])
        Pr0b=as.numeric(Pr0[,j])
        for (k in 1:length(model.y$lev)){
          a=which(Pr1b>seuilY[k] & Pr1b<=seuilY[k+1])
          b=which(Pr0b>seuilY[k] & Pr0b<=seuilY[k+1])
          Pr1[a,j]=model.y$lev[k]
          Pr0[b,j]=model.y$lev[k]
        }
        Pr1=matrix(as.numeric(Pr1),N,J)
        Pr0=matrix(as.numeric(Pr0),N,J)
      }

      if (NM!=1 & e<=2) {

        for (nm in 1:NM){
          if (tt[3]==1){
            PredictMt=PredictM1[j,,nm]
          } else {
            PredictMt=PredictM0[j,,nm]
          }
          if (tt[1]==1){
            PredictWt=PredictM1[j,,-nm]
          } else {
            PredictWt=PredictM0[j,,-nm]
          }

          if (tt[4]==1){
            PredictMc=PredictM1[j,,nm]
          } else {
            PredictMc=PredictM0[j,,nm]
          }
          if (tt[2]==1){
            PredictWc=PredictM1[j,,-nm]
          } else {
            PredictWc=PredictM0[j,,-nm]
          }


          pred.data.t[, mediator[nm]] <- PredictMt
          pred.data.t[, mediator[-nm]] <- PredictWt
          pred.data.c[, mediator[nm]] <- PredictMc
          pred.data.c[, mediator[-nm]] <- PredictWc
          for (nmt in 1:NM){
            if(inherits(lmodel.m[[nmt]],"polr")){

              pred.data.c[,mediator[nmt]]=as.factor(pred.data.c[,mediator[nmt]])
              levels(pred.data.c[,mediator[nmt]])=lmodel.m[[nmt]]$lev
              pred.data.t[,mediator[nmt]]=as.factor(pred.data.t[,mediator[nmt]])
              levels(pred.data.t[,mediator[nmt]])=lmodel.m[[nmt]]$lev
            }

            if(inherits(lmodel.m[[nmt]],"lm") & !inherits(lmodel.m[[nmt]],"glm")){
              pred.data.c[,mediator[nmt]]=as.numeric(pred.data.c[,mediator[nmt]])
              pred.data.t[,mediator[nmt]]=as.numeric(pred.data.t[,mediator[nmt]])
            }

            if(inherits(lmodel.m[[nmt]],"glm")){
              pred.data.c[,mediator[nmt]]=as.factor(pred.data.c[,mediator[nmt]])
              levels(pred.data.c[,mediator[nmt]])=levels(lmodel.m[[nmt]]$model[,1])
              pred.data.t[,mediator[nmt]]=as.factor(pred.data.t[,mediator[nmt]])
              levels(pred.data.t[,mediator[nmt]])=levels(lmodel.m[[nmt]]$model[,1])
            }
          }

          if(inherits(model.y, "aalen")){
            trans.t <- model.matrix(~ ., data=data[,getvarnames(model.y$call)$xvar])[,-1]
            trans.t[, grep(treat,colnames(trans.t))] <- as.numeric(as.character(pred.data.t[, treat]))
            mediator_y <- get_levels_except_first(data, mediator)
            trans.t[, mediator_y] <- as.matrix(apply(pred.data.t[, mediator, drop = FALSE], 2, function(x) as.numeric(as.character(x))))

            trans.c <- model.matrix(~ ., data=data[,getvarnames(model.y$call)$xvar])[,-1]
            trans.c[, grep(treat,colnames(trans.c))] <- as.numeric(as.character(pred.data.c[, treat]))
            trans.c[, mediator_y] <- as.matrix(apply(pred.data.c[, mediator, drop = FALSE], 2, function(x) as.numeric(as.character(x))))

            ymat.t = trans.t
            ymat.c = trans.c


            if(length(grep(' * ', row.names(coef(model.y))))>0){
              ymat.t = as.data.frame(trans.t)
              ymat.c = as.data.frame(trans.c)
              position <- grep(' * ', row.names(coef(model.y)))
              count <- 0
              order <- unlist(strsplit(substr(row.names(coef(model.y)), 7, unlist(gregexpr(')', row.names(coef(model.y))))),')'))
              for(i in mediator){
                count <- count + 1
                if (grepl(i, row.names(coef(model.y))[position[count]])){
                  med_int <- i
                  order[position[count]] <- paste0('interaction_', count)
                  ymat.t[,paste0('interaction_', count)] <- ymat.t[,treat]*ymat.t[,med_int]
                  ymat.c[,paste0('interaction_', count)] <- ymat.c[,treat]*ymat.c[,med_int]
                }
              }
              ymat.t <- as.matrix(ymat.t[,pmatch(order, colnames(ymat.t))])
              ymat.c <- as.matrix(ymat.c[,pmatch(order, colnames(ymat.c))])
            }
          } else{
            ymat.t=ymat.c=model.matrix(model.y)
            trans.t <- model.matrix(terms(model.y), data = pred.data.t)
            trans.c <- model.matrix(terms(model.y), data = pred.data.c)

            ymat.t[,colnames(ymat.t) %in% colnames(trans.t)]=trans.t
            ymat.t[,!(colnames(ymat.t) %in% colnames(trans.t))]=0
            ymat.c[,colnames(ymat.c) %in% colnames(trans.c)]=trans.c
            ymat.c[,!(colnames(ymat.c) %in% colnames(trans.c))]=0


            if(!inherits(model.y,"polr") & length(grep(':', names(coef(model.y))))>0){
              ymat.t <- as.data.frame(ymat.t)
              ymat.c <- as.data.frame(ymat.c)
              position <- grep(':', names(coef(model.y)))
              for(i in mediator){
                if (grepl(i, names(coef(model.y))[position])){
                  med_int <- i
                }
              }

            order <- names(coef(model.y))
            order[position] <- 'interaction'
            ymat.t$interaction <- ymat.t$Exposant*ymat.t[,med_int]
            ymat.t <- as.matrix(ymat.t[,order])
            ymat.c$interaction <- ymat.c$Exposant*ymat.c[,med_int]
            ymat.c <- as.matrix(ymat.c[,order])
            }
          }



          if(!inherits(model.y,"polr")){
            if(inherits(model.y, "aalen")){
              Pr1.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
              Pr0.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
            } else{
              Pr1.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)+ Yerror
              Pr0.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)+ Yerror
            }
            ORPr1.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.t)
            ORPr0.NM[,j,nm] <- t(as.matrix(YModel[j, ])) %*% t(ymat.c)
          } else{
            ymat.t=ymat.t[,-1]
            ymat.c=ymat.c[,-1]
            Pr1.NM[,j,nm] <- t(as.matrix(YModel[j,1:dim(ymat.t)[2]])) %*% t(ymat.t)
            Pr0.NM[,j,nm] <- t(as.matrix(YModel[j,1:dim(ymat.c)[2]])) %*% t(ymat.c)

            Pr1b.NM=as.numeric(Pr1.NM[,j,nm])
            Pr0b.NM=as.numeric(Pr0.NM[,j,nm])
            for (k in 1:length(model.y$lev)){
              a=which(Pr1b.NM>seuilY[k] & Pr1b.NM<=seuilY[k+1])
              b=which(Pr0b.NM>seuilY[k] & Pr0b.NM<=seuilY[k+1])
              Pr1.NM[a,j,nm]=model.y$lev[k]
              Pr0.NM[b,j,nm]=model.y$lev[k]
            }
            Pr1.NM=array(as.numeric(Pr1.NM),dim=c(N,J,NM))
            Pr0.NM=array(as.numeric(Pr0.NM),dim=c(N,J,NM))
          }
        }
      }
      if (isTRUE(verbose)) setTxtProgressBar(pb, j,title=title[e])
    }
    if (isTRUE(verbose)) close(pb)

    if (!is.null(model.y$family)){

      effect.tmp[,,e]=(Pr1>0)-(Pr0>0)
      if (model.y$family$link=="logit"){

        expit=function(x){
          res=1/(1+exp(-x))
          return(res)
        }

        OR[,,e]=((1-expit(ORPr0))/expit(ORPr0))*((expit(ORPr1))/(1-expit(ORPr1)))
      }
      if (NM!=1 & e<=2){

        effect.tmp.NM[,,e,]=(Pr1.NM>0)-(Pr0.NM>0)
        if (model.y$family$link=="logit"){
          OR.NM[,,e,]=((1-expit(ORPr0.NM))/expit(ORPr0.NM))*((expit(ORPr1.NM))/(1-expit(ORPr1.NM)))
        }

      }
    } else {
      if(inherits(model.y, "aalen")){
        effect.tmp[,,e]=(Pr1-Pr0)*peryr
      } else{
        effect.tmp[,,e]=Pr1-Pr0
      }



      if (NM!=1 & e<=2){
        if(inherits(model.y, "aalen")){
          effect.tmp.NM[,,e,]=(Pr1.NM-Pr0.NM)*peryr
        } else{
          effect.tmp.NM[,,e,]=(Pr1.NM-Pr0.NM)
        }

      }
    }
  }
  if (isTRUE(verbose)) message("Computing average point estimates together with p-values and confidence intervals")


  et1 <- effect.tmp[, , 1] # joint mediated effect delta(1)
  et2 <- effect.tmp[, , 2] # joint mediated effect delta(0)
  et3 <- effect.tmp[, , 3] # direct effect zeta(1)
  et4 <- effect.tmp[, , 4] # direct effect zeta(0)

  delta.1 <- t(as.matrix(apply(et1, 2, mean,na.rm=TRUE)))
  delta.0 <- t(as.matrix(apply(et2, 2, mean,na.rm=TRUE)))

  zeta.1 <- t(as.matrix(apply(et3, 2, mean,na.rm=TRUE)))
  zeta.0 <- t(as.matrix(apply(et4, 2, mean,na.rm=TRUE)))

  tau <- (zeta.1 + delta.0 + zeta.0 + delta.1)/2
  nu.0 <- delta.0/tau
  nu.1 <- delta.1/tau
  delta.avg <- (delta.1 + delta.0)/2
  zeta.avg <- (zeta.1 + zeta.0)/2
  nu.avg <- (nu.1 + nu.0)/2
  d0 <- fun(delta.0,na.rm=TRUE)
  d1 <- fun(delta.1,na.rm=TRUE)
  z1 <- fun(zeta.1,na.rm=TRUE)
  z0 <- fun(zeta.0,na.rm=TRUE)
  tau.coef <- fun(tau,na.rm=TRUE)
  n0 <- fun(nu.0*is.finite(nu.0),na.rm=TRUE)
  n1 <- fun(nu.1*is.finite(nu.1),na.rm=TRUE)
  d.avg <- (d0 + d1)/2
  z.avg <- (z0 + z1)/2
  n.avg <- (n0 + n1)/2

  if (!is.null(model.y$family)){
    if ( model.y$family$link=="logit"){
      ORet1 <- OR[ , ,1] # joint mediated effect ORdelta(1)
      ORet2 <- OR[ , ,2] # joint mediated effect ORdelta(0)
      ORet3  <- OR[ , ,3] # direct effect ORzeta(1)
      ORet4  <- OR[ , ,4] # direct effect ORzeta(0)
      ORdelta.1 <- t(as.matrix(apply(ORet1, 2, mean,na.rm=TRUE)))
      ORdelta.0 <- t(as.matrix(apply(ORet2, 2, mean,na.rm=TRUE)))
      ORzeta.1 <- t(as.matrix(apply(ORet3, 2, mean,na.rm=TRUE)))
      ORzeta.0 <- t(as.matrix(apply(ORet4, 2, mean,na.rm=TRUE)))

      ORtau <- (ORzeta.1*ORdelta.0 + ORzeta.0*ORdelta.1)/2
      ORnu.1 <- ORzeta.0*(ORdelta.1-1)/(ORzeta.0*ORdelta.1-1)
      ORnu.0 <- ORzeta.1*(ORdelta.0-1)/(ORzeta.1*ORdelta.0-1)

      ORtau.coef <- fun(ORtau,na.rm=TRUE)

      ORdelta.avg <- (ORdelta.1 + ORdelta.0)/2
      ORnu.avg <- (ORnu.1 + ORnu.0)/2
      ORzeta.avg <- (ORzeta.1 + ORzeta.0)/2

      ORd1 <- fun(ORdelta.1*is.finite(ORdelta.1),na.rm=TRUE)
      ORn1 <- fun(ORnu.1*is.finite(ORnu.1),na.rm=TRUE)
      ORd0 <- fun(ORdelta.0*is.finite(ORdelta.0),na.rm=TRUE)
      ORn0 <- fun(ORnu.0*is.finite(ORnu.0),na.rm=TRUE)
      ORz1 <- fun(ORzeta.1*is.finite(ORzeta.1),na.rm=TRUE)
      ORz0 <- fun(ORzeta.0*is.finite(ORzeta.0),na.rm=TRUE)

      ORd.avg <- (ORd0 + ORd1)/2
      ORz.avg <- (ORz0 + ORz1)/2
      ORn.avg <- (ORn0 + ORn1)/2

      logORdelta.1 <- log(ORdelta.1)
      logORtau <- log(ORtau)
      logORnu.1 <- logORdelta.1/logORtau
      logORdelta.0 <- log(ORdelta.0)
      logORnu.0 <- logORdelta.0/logORtau
      logORzeta.1 <- log(ORzeta.1)
      logORzeta.0 <- log(ORzeta.0)

      logORtau.coef <- fun(logORtau*is.finite(logORtau),na.rm=TRUE)
      logORnu.avg <- (logORnu.1 + logORnu.0)/2
      logORn0 <- fun(logORnu.0*is.finite(logORnu.0),na.rm=TRUE)
      logORn1 <- fun(logORnu.1*is.finite(logORnu.1),na.rm=TRUE)
      logORn.avg <- (logORn0 + logORn1)/2

      logORdelta.avg <- (logORdelta.1 + logORdelta.0)/2
      logORzeta.avg <- (logORzeta.1 + logORzeta.0)/2
      logORd0 <- fun(logORdelta.0*is.finite(logORdelta.0),na.rm=TRUE)
      logORd1 <- fun(logORdelta.1*is.finite(logORdelta.1),na.rm=TRUE)
      logORz1 <- fun(logORzeta.1*is.finite(logORzeta.1),na.rm=TRUE)
      logORz0 <- fun(logORzeta.0*is.finite(logORzeta.0),na.rm=TRUE)
      logORtau.coef <- fun(logORtau*is.finite(logORtau),na.rm=TRUE)
      logORd.avg <- (logORd0 + logORd1)/2
      logORz.avg <- (logORz0 + logORz1)/2
    }}

  if (NM!=1){
    et5 <- effect.tmp.NM[, ,1,]
    et6 <- effect.tmp.NM[, ,2,]

    delta.1.NM <- t((apply(et5, c(2,3), mean)))
    eta.1.NM <- array(delta.1,dim=c(NM,J))-delta.1.NM
    delta.0.NM <- t(as.matrix(apply(et6, c(2,3), mean)))
    eta.0.NM <- array(delta.0,dim=c(NM,J))-delta.0.NM

    nu.0.NM <- delta.0.NM/array(tau,dim=c(NM,J))
    nu.1.NM <- delta.1.NM/array(tau,dim=c(NM,J))
    delta.avg.NM <- (delta.1.NM + delta.0.NM)/2
    nu.avg.NM <- (nu.1.NM + nu.0.NM)/2
    d0.NM <- apply(delta.0.NM*is.finite(delta.0.NM),1,fun,na.rm=TRUE)
    d1.NM <- apply(delta.1.NM*is.finite(delta.1.NM),1,fun,na.rm=TRUE)
    n0.NM <- apply(nu.0.NM*is.finite(nu.0.NM),1,fun,na.rm=TRUE)
    n1.NM <- apply(nu.1.NM*is.finite(nu.1.NM),1,fun,na.rm=TRUE)
    d.avg.NM <- (d0.NM + d1.NM)/2
    n.avg.NM <- (n0.NM + n1.NM)/2

    if (!is.null(model.y$family)){
      if (model.y$family$link=="logit"){
        ORet5 <- OR.NM[, ,1,]
        ORet6 <- OR.NM[, ,2,]
        ORdelta.1.NM <- t((apply(ORet5, c(2,3), mean)))
        OReta.1.NM <- array(ORdelta.1,dim=c(NM,J))/ORdelta.1.NM
        ORdelta.0.NM <- t(as.matrix(apply(ORet6, c(2,3), mean)))
        OReta.0.NM <- array(ORdelta.0,dim=c(NM,J))/ORdelta.0.NM

        ORnu.0.NM <- array(ORzeta.1,dim=c(NM,J))*OReta.0.NM*(ORdelta.0.NM-1)/(array(ORzeta.1*ORdelta.0,dim=c(NM,J))-1)
        ORnu.1.NM <- array(ORzeta.0,dim=c(NM,J))*OReta.1.NM*(ORdelta.1.NM-1)/(array(ORzeta.0*ORdelta.1,dim=c(NM,J))-1)
        ORdelta.avg.NM <- (ORdelta.1.NM + ORdelta.0.NM)/2
        ORnu.avg.NM <- (ORnu.1.NM + ORnu.0.NM)/2
        ORd0.NM <- apply(ORdelta.0.NM*is.finite(ORdelta.0.NM),1,fun,na.rm=TRUE)
        ORd1.NM <- apply(ORdelta.1.NM*is.finite(ORdelta.1.NM),1,fun,na.rm=TRUE)
        ORn0.NM <- apply(ORnu.0.NM*is.finite(ORnu.0.NM),1,fun,na.rm=TRUE)
        ORn1.NM <- apply(ORnu.1.NM*is.finite(ORnu.1.NM),1,fun,na.rm=TRUE)
        ORd.avg.NM <- (ORd0.NM + ORd1.NM)/2
        ORn.avg.NM <- (ORn0.NM + ORn1.NM)/2



        logORdelta.1.NM <- log(ORdelta.1.NM)
        logORdelta.0.NM <- log(ORdelta.0.NM)
        logORnu.0.NM <- logORdelta.0.NM/array(logORtau,dim=c(NM,J))
        logORnu.1.NM <- logORdelta.1.NM/array(logORtau,dim=c(NM,J))

        logORnu.avg.NM <- (logORnu.1.NM + logORnu.0.NM)/2
        logORn0.NM <- apply(logORdelta.0.NM/logORtau.coef,1,fun,na.rm=TRUE)
        logORn1.NM <- apply(logORdelta.1.NM/logORtau.coef,1,fun,na.rm=TRUE)
        logORn.avg.NM <- (logORn0.NM + logORn1.NM)/2

        logORdelta.avg.NM <- (logORdelta.1.NM + logORdelta.0.NM)/2
        logORd0.NM <- apply(logORdelta.0.NM,1,fun,na.rm=TRUE)
        logORd1.NM <- apply(logORdelta.1.NM,1,fun,na.rm=TRUE)
        logORd.avg.NM <- (logORd0.NM + logORd1.NM)/2
      }}

  } else {
    delta.1.NM <- delta.0.NM <- NULL
    if (!is.null(model.y$family)){
      if (model.y$family$link=="logit"){
        ORdelta.1.NM <- ORdelta.0.NM <- logORdelta.1.NM <- logORdelta.0.NM <- NULL
      }}
  }


  low <- (1 - conf.level)/2
  high <- 1 - low

  d0.ci <- quantile(delta.0, c(low, high), na.rm = TRUE)
  d1.ci <- quantile(delta.1, c(low, high), na.rm = TRUE)
  tau.ci <- quantile(tau, c(low, high), na.rm = TRUE)
  z1.ci <- quantile(zeta.1, c(low, high), na.rm = TRUE)
  z0.ci <- quantile(zeta.0, c(low, high), na.rm = TRUE)
  n0.ci <- quantile(nu.0, c(low, high), na.rm = TRUE)
  n1.ci <- quantile(nu.1, c(low, high), na.rm = TRUE)
  d.avg.ci <- quantile(delta.avg, c(low, high), na.rm = TRUE)
  z.avg.ci <- quantile(zeta.avg, c(low, high), na.rm = TRUE)
  n.avg.ci <- quantile(nu.avg, c(low, high), na.rm = TRUE)

  d0.p <- pval(delta.0, d0)
  d1.p <- pval(delta.1, d1)
  d.avg.p <- pval(delta.avg, d.avg)
  z0.p <- pval(zeta.0, z0)
  z1.p <- pval(zeta.1, z1)
  z.avg.p <- pval(zeta.avg, z.avg)
  n0.p <- pval(nu.0, n0)
  n1.p <- pval(nu.1, n1)
  n.avg.p <- pval(nu.avg, n.avg)
  tau.p <- pval(tau, tau.coef)

  if (!is.null(model.y$family)){
    if (model.y$family$link=="logit"){
      ORd0.ci <- quantile(ORdelta.0, c(low, high), na.rm = TRUE)
      ORd1.ci <- quantile(ORdelta.1, c(low, high), na.rm = TRUE)
      ORtau.ci <- quantile(ORtau, c(low, high), na.rm = TRUE)
      ORz1.ci <- quantile(ORzeta.1, c(low, high), na.rm = TRUE)
      ORz0.ci <- quantile(ORzeta.0, c(low, high), na.rm = TRUE)
      ORn0.ci <- quantile(ORnu.0, c(low, high), na.rm = TRUE)
      ORn1.ci <- quantile(ORnu.1, c(low, high), na.rm = TRUE)

      ORd.avg.ci <- quantile(ORdelta.avg, c(low, high), na.rm = TRUE)
      ORz.avg.ci <- quantile(ORzeta.avg, c(low, high), na.rm = TRUE)
      ORn.avg.ci <- quantile(ORnu.avg, c(low, high), na.rm = TRUE)

      ORd0.p <- pval(ORdelta.0, ORd0,seu=1)
      ORd1.p <- pval(ORdelta.1, ORd1,seu=1)
      ORd.avg.p <- pval(ORdelta.avg, ORd.avg,seu=1)
      ORz0.p <- pval(ORzeta.0, ORz0,seu=1)
      ORz1.p <- pval(ORzeta.1, ORz1,seu=1)
      ORz.avg.p <- pval(ORzeta.avg, ORz.avg,seu=1)
      ORn0.p <- pval(ORnu.0, ORn0)
      ORn1.p <- pval(ORnu.1, ORn1)
      ORn.avg.p <- pval(ORnu.avg, ORn.avg)
      ORtau.p <- pval(ORtau, ORtau.coef,seu=1)

      logORn0.ci <- quantile(logORnu.0, c(low, high), na.rm = TRUE)
      logORn1.ci <- quantile(logORnu.1, c(low, high), na.rm = TRUE)
      logORn.avg.ci <- quantile(logORnu.avg, c(low, high), na.rm = TRUE)
      logORn0.p <- pval(logORnu.0, logORn0)
      logORn1.p <- pval(logORnu.1, logORn1)
      logORn.avg.p <- pval(logORnu.avg, logORn.avg)
      logORd0.ci <- quantile(logORdelta.0, c(low, high), na.rm = TRUE)
      logORd1.ci <- quantile(logORdelta.1, c(low, high), na.rm = TRUE)
      logORtau.ci <- quantile(logORtau, c(low, high), na.rm = TRUE)
      logORz1.ci <- quantile(logORzeta.1, c(low, high), na.rm = TRUE)
      logORz0.ci <- quantile(logORzeta.0, c(low, high), na.rm = TRUE)
      logORd.avg.ci <- quantile(logORdelta.avg, c(low, high), na.rm = TRUE)
      logORz.avg.ci <- quantile(logORzeta.avg, c(low, high), na.rm = TRUE)

      logORd0.p <- pval(logORdelta.0, logORd0)
      logORd1.p <- pval(logORdelta.1, logORd1)
      logORd.avg.p <- pval(logORdelta.avg, logORd.avg)
      logORz0.p <- pval(logORzeta.0, logORz0)
      logORz1.p <- pval(logORzeta.1, logORz1)
      logORz.avg.p <- pval(logORzeta.avg, logORz.avg)
      logORtau.p <- pval(logORtau, logORtau.coef)
    }}


  if(NM!=1){
    d0.ci.NM <- d1.ci.NM <- n0.ci.NM <- n1.ci.NM <- d.avg.ci.NM <- n.avg.ci.NM <- array(NA,dim=c(NM,2))
    d0.p.NM <- d1.p.NM <- d.avg.p.NM <- n0.p.NM <- n1.p.NM <- n.avg.p.NM <- rep(NA,NM)
    for (nm in 1:NM){
      d0.ci.NM[nm,] <- quantile(delta.0.NM[nm,], c(low, high), na.rm = TRUE)
      d1.ci.NM[nm,] <- quantile(delta.1.NM[nm,], c(low, high), na.rm = TRUE)
      n0.ci.NM[nm,] <- quantile(nu.0.NM[nm,], c(low, high), na.rm = TRUE)
      n1.ci.NM[nm,] <- quantile(nu.1.NM[nm,], c(low, high), na.rm = TRUE)
      d.avg.ci.NM[nm,] <- quantile(delta.avg.NM[nm,], c(low, high), na.rm = TRUE)
      n.avg.ci.NM[nm,] <- quantile(nu.avg.NM[nm,], c(low, high), na.rm = TRUE)

      d0.p.NM[nm] <- pval(delta.0.NM[nm,], d0.NM[nm])
      d1.p.NM[nm] <- pval(delta.1.NM[nm,], d1.NM[nm])
      d.avg.p.NM[nm] <- pval(delta.avg.NM[nm,], d.avg.NM[nm])
      n0.p.NM[nm] <- pval(nu.0.NM[nm,], n0.NM[nm])
      n1.p.NM[nm] <- pval(nu.1.NM[nm,], n1.NM[nm])
      n.avg.p.NM[nm] <- pval(nu.avg.NM[nm,], n.avg.NM[nm])
    }

    if (!is.null(model.y$family)){
      if (model.y$family$link=="logit"){
        ORd0.ci.NM <- ORd1.ci.NM <- ORn0.ci.NM <- ORn1.ci.NM <-ORd.avg.ci.NM <- ORn.avg.ci.NM <- array(NA,dim=c(NM,2))
        ORd0.p.NM <- ORd1.p.NM <- ORd.avg.p.NM <- ORn0.p.NM <- ORn1.p.NM <- ORn.avg.p.NM<- rep(NA,NM)

        logORd0.ci.NM <- logORd1.ci.NM <- logORn0.ci.NM <- logORn1.ci.NM <- logORd.avg.ci.NM <- logORn.avg.ci.NM <- array(NA,dim=c(NM,2))
        logORd0.p.NM <- logORd1.p.NM <- logORd.avg.p.NM <- logORn0.p.NM <- logORn1.p.NM <- logORn.avg.p.NM <- rep(NA,NM)
        for (nm in 1:NM){
          ORd0.ci.NM[nm,] <- quantile(ORdelta.0.NM[,nm], c(low, high), na.rm = TRUE)
          ORd1.ci.NM[nm,] <- quantile(ORdelta.1.NM[,nm], c(low, high), na.rm = TRUE)
          ORn0.ci.NM[nm,] <- quantile(ORnu.0.NM[,nm], c(low, high), na.rm = TRUE)
          ORn1.ci.NM[nm,] <- quantile(ORnu.1.NM[,nm], c(low, high), na.rm = TRUE)
          ORd.avg.ci.NM[nm,] <- quantile(ORdelta.avg.NM[,nm], c(low, high), na.rm = TRUE)
          ORn.avg.ci.NM[nm,] <- quantile(ORnu.avg.NM[,nm], c(low, high), na.rm = TRUE)

          ORd0.p.NM[nm] <- pval(ORdelta.0.NM[,nm], ORd0.NM[nm],seu=1)
          ORd1.p.NM[nm] <- pval(ORdelta.1.NM[,nm], ORd1.NM[nm],seu=1)
          ORd.avg.p.NM[nm] <- pval(ORdelta.avg.NM[,nm], ORd.avg.NM[nm],seu=1)
          ORn0.p.NM[nm] <- pval(ORnu.0.NM[,nm], ORn0.NM[nm])
          ORn1.p.NM[nm] <- pval(ORnu.1.NM[,nm], ORn1.NM[nm])
          ORn.avg.p.NM[nm] <- pval(ORnu.avg.NM[,nm], ORn.avg.NM[nm])

          logORd0.ci.NM[nm,] <- quantile(logORdelta.0.NM[,nm], c(low, high), na.rm = TRUE)
          logORd1.ci.NM[nm,] <- quantile(logORdelta.1.NM[,nm], c(low, high), na.rm = TRUE)
          logORd.avg.ci.NM[nm,] <- quantile(logORdelta.avg.NM[,nm], c(low, high), na.rm = TRUE)
          logORn0.ci.NM[nm,] <- quantile(logORnu.0.NM[,nm], c(low, high), na.rm = TRUE)
          logORn1.ci.NM[nm,] <- quantile(logORnu.1.NM[,nm], c(low, high), na.rm = TRUE)
          logORn.avg.ci.NM[nm,] <- quantile(logORnu.avg.NM[,nm], c(low, high), na.rm = TRUE)
          logORd0.p.NM[nm] <- pval(logORdelta.0.NM[,nm], logORd0.NM[nm])
          logORd1.p.NM[nm] <- pval(logORdelta.1.NM[,nm], logORd1.NM[nm])
          logORd.avg.p.NM[nm] <- pval(logORdelta.avg.NM[,nm], logORd.avg.NM[nm])
          logORn0.p.NM[nm] <- pval(logORnu.0.NM[,nm], logORn0.NM[nm])
          logORn1.p.NM[nm] <- pval(logORnu.1.NM[,nm], logORn1.NM[nm])
          logORn.avg.p.NM[nm] <- pval(logORnu.avg.NM[,nm], logORn.avg.NM[nm])
        }


      }}
  }
  if (NM==1){
    out <- list(d0 = d0, d1 = d1, d0.ci = d0.ci, d1.ci = d1.ci, d0.p = d0.p, d1.p = d1.p, d0.sims = delta.0,d1.sims = delta.1,
                z0 = z0, z1 = z1, z0.ci = z0.ci,z1.ci = z1.ci, z0.p = z0.p, z1.p = z1.p, z0.sims = zeta.0, z1.sims = zeta.1,
                n0 = n0, n1 = n1, n0.ci = n0.ci, n1.ci = n1.ci, n0.p = n0.p, n1.p = n1.p, n0.sims = nu.0, n1.sims = nu.1,
                tau.coef = tau.coef, tau.ci = tau.ci, tau.p = tau.p, tau.sims = tau,
                d.avg = d.avg, d.avg.p = d.avg.p, d.avg.ci = d.avg.ci, d.avg.sims = delta.avg,
                z.avg = z.avg, z.avg.p = z.avg.p, z.avg.ci = z.avg.ci, z.avg.sims = zeta.avg,
                n.avg = n.avg, n.avg.p = n.avg.p, n.avg.ci = n.avg.ci, n.avg.sims = nu.avg,
                treat = treat, mediator = mediator,
                conf.level = conf.level,
                model.y = model.y, model.m = lmodel.m,
                control.value = control.value, treat.value = treat.value,
                nobs = N, sims = J,cov=cov,cor=cor)
    if (!is.null(model.y$family)){
      if (model.y$family$link=="logit"){
        out <- list(d0 = d0, d1 = d1, d0.ci = d0.ci, d1.ci = d1.ci, d0.p = d0.p, d1.p = d1.p, d0.sims = delta.0,d1.sims = delta.1,
                    z0 = z0, z1 = z1, z0.ci = z0.ci,z1.ci = z1.ci, z0.p = z0.p, z1.p = z1.p, z0.sims = zeta.0, z1.sims = zeta.1,
                    n0 = n0, n1 = n1, n0.ci = n0.ci, n1.ci = n1.ci, n0.p = n0.p, n1.p = n1.p, n0.sims = nu.0, n1.sims = nu.1,
                    tau.coef = tau.coef, tau.ci = tau.ci, tau.p = tau.p, tau.sims = tau,
                    d.avg = d.avg, d.avg.p = d.avg.p, d.avg.ci = d.avg.ci, d.avg.sims = delta.avg,
                    z.avg = z.avg, z.avg.p = z.avg.p, z.avg.ci = z.avg.ci, z.avg.sims = zeta.avg,
                    n.avg = n.avg, n.avg.p = n.avg.p, n.avg.ci = n.avg.ci, n.avg.sims = nu.avg,
                    treat = treat, mediator = mediator,
                    conf.level = conf.level,
                    model.y = model.y, model.m = lmodel.m,
                    control.value = control.value, treat.value = treat.value,
                    nobs = N, sims = J,cov=cov,cor=cor,
                    ORd0 = ORd0, ORd1 = ORd1, ORd0.ci = ORd0.ci, ORd1.ci = ORd1.ci, ORd0.p = ORd0.p, ORd1.p = ORd1.p, ORd0.sims = ORdelta.0,ORd1.sims = ORdelta.1,
                    ORz0 = ORz0, ORz1 = ORz1, ORz0.ci = ORz0.ci,ORz1.ci = ORz1.ci, ORz0.p = ORz0.p, ORz1.p = ORz1.p, ORz0.sims = ORzeta.0, ORz1.sims = ORzeta.1,
                    ORn0 = ORn0, ORn1 = ORn1, ORn0.ci = ORn0.ci, ORn1.ci = ORn1.ci, ORn0.p = ORn0.p, ORn1.p = ORn1.p, ORn0.sims = ORnu.0, ORn1.sims = ORnu.1,
                    ORtau.coef = ORtau.coef, ORtau.ci = ORtau.ci, ORtau.p = ORtau.p, ORtau.sims = ORtau,
                    ORd.avg = ORd.avg, ORd.avg.p = ORd.avg.p, ORd.avg.ci = ORd.avg.ci, ORd.avg.sims = ORdelta.avg,
                    ORz.avg = ORz.avg, ORz.avg.p = ORz.avg.p, ORz.avg.ci = ORz.avg.ci, ORz.avg.sims = ORzeta.avg,
                    ORn.avg = ORn.avg, ORn.avg.p = ORn.avg.p, ORn.avg.ci = ORn.avg.ci, ORn.avg.sims = ORnu.avg,
                    logORd0 = logORd0, logORd1 = logORd1, logORd0.ci = logORd0.ci, logORd1.ci = logORd1.ci, logORd0.p = logORd0.p, logORd1.p = logORd1.p, logORd0.sims = logORdelta.0,logORd1.sims = logORdelta.1,
                    logORz0 = logORz0, logORz1 = logORz1, logORz0.ci = logORz0.ci,logORz1.ci = logORz1.ci, logORz0.p = logORz0.p, logORz1.p = logORz1.p, logORz0.sims = logORzeta.0, logORz1.sims = logORzeta.1,
                    logORn0 = logORn0, logORn1 = logORn1, logORn0.ci = logORn0.ci, logORn1.ci = logORn1.ci, logORn0.p = logORn0.p, logORn1.p = logORn1.p, logORn0.sims = logORnu.0, logORn1.sims = logORnu.1,
                    logORtau.coef = logORtau.coef, logORtau.ci = logORtau.ci, logORtau.p = logORtau.p, logORtau.sims = logORtau,
                    logORd.avg = logORd.avg, logORd.avg.p = logORd.avg.p, logORd.avg.ci = logORd.avg.ci, logORd.avg.sims = logORdelta.avg,
                    logORz.avg = logORz.avg, logORz.avg.p = logORz.avg.p, logORz.avg.ci = logORz.avg.ci, logORz.avg.sims = logORzeta.avg,
                    logORn.avg = logORn.avg, logORn.avg.p = logORn.avg.p, logORn.avg.ci = logORn.avg.ci, logORn.avg.sims = logORnu.avg)
      }}
  } else {
    out <- list(d0 = d0, d1 = d1, d0.ci = d0.ci, d1.ci = d1.ci, d0.p = d0.p, d1.p = d1.p, d0.sims = delta.0,d1.sims = delta.1,
                d0.NM = d0.NM, d1.NM = d1.NM, d0.ci.NM = d0.ci.NM, d1.ci.NM = d1.ci.NM, d0.p.NM = d0.p.NM, d1.p.NM = d1.p.NM, d0.sims.NM = delta.0.NM, d1.sims.NM = delta.1.NM,
                z0 = z0, z1 = z1, z0.ci = z0.ci,z1.ci = z1.ci, z0.p = z0.p, z1.p = z1.p, z0.sims = zeta.0, z1.sims = zeta.1,
                n0 = n0, n1 = n1, n0.ci = n0.ci, n1.ci = n1.ci, n0.p = n0.p, n1.p = n1.p, n0.sims = nu.0, n1.sims = nu.1,
                n0.NM = n0.NM, n1.NM = n1.NM, n0.ci.NM = n0.ci.NM, n1.ci.NM = n1.ci.NM, n0.p.NM = n0.p.NM, n1.p.NM = n1.p.NM, n0.sims.NM = nu.0.NM, n1.sims.NM = nu.1.NM,
                tau.coef = tau.coef, tau.ci = tau.ci, tau.p = tau.p, tau.sims = tau,
                d.avg = d.avg, d.avg.p = d.avg.p, d.avg.ci = d.avg.ci, d.avg.sims = delta.avg,
                d.avg.NM = d.avg.NM, d.avg.p.NM = d.avg.p.NM, d.avg.ci.NM = d.avg.ci.NM, d.avg.sims.NM = delta.avg.NM,
                z.avg = z.avg, z.avg.p = z.avg.p, z.avg.ci = z.avg.ci, z.avg.sims = zeta.avg,
                n.avg = n.avg, n.avg.p = n.avg.p, n.avg.ci = n.avg.ci, n.avg.sims = nu.avg,
                n.avg.NM = n.avg.NM, n.avg.p.NM = n.avg.p.NM, n.avg.ci.NM = n.avg.ci.NM, n.avg.sims.NM = nu.avg.NM,
                treat = treat, mediator = mediator,
                conf.level = conf.level,
                model.y = model.y, model.m = lmodel.m,
                control.value = control.value, treat.value = treat.value,
                nobs = N, sims = J,cov=cov,cor=cor)

    if (!is.null(model.y$family)){
      if (model.y$family$link=="logit"){
        out <- list(d0 = d0, d1 = d1, d0.ci = d0.ci, d1.ci = d1.ci, d0.p = d0.p, d1.p = d1.p, d0.sims = delta.0,d1.sims = delta.1,
                    d0.NM = d0.NM, d1.NM = d1.NM, d0.ci.NM = d0.ci.NM, d1.ci.NM = d1.ci.NM, d0.p.NM = d0.p.NM, d1.p.NM = d1.p.NM, d0.sims.NM = delta.0.NM, d1.sims.NM = delta.1.NM,
                    z0 = z0, z1 = z1, z0.ci = z0.ci,z1.ci = z1.ci, z0.p = z0.p, z1.p = z1.p, z0.sims = zeta.0, z1.sims = zeta.1,
                    n0 = n0, n1 = n1, n0.ci = n0.ci, n1.ci = n1.ci, n0.p = n0.p, n1.p = n1.p, n0.sims = nu.0, n1.sims = nu.1,
                    n0.NM = n0.NM, n1.NM = n1.NM, n0.ci.NM = n0.ci.NM, n1.ci.NM = n1.ci.NM, n0.p.NM = n0.p.NM, n1.p.NM = n1.p.NM, n0.sims.NM = nu.0.NM, n1.sims.NM = nu.1.NM,
                    tau.coef = tau.coef, tau.ci = tau.ci, tau.p = tau.p, tau.sims = tau,
                    d.avg = d.avg, d.avg.p = d.avg.p, d.avg.ci = d.avg.ci, d.avg.sims = delta.avg,
                    d.avg.NM = d.avg.NM, d.avg.p.NM = d.avg.p.NM, d.avg.ci.NM = d.avg.ci.NM, d.avg.sims.NM = delta.avg.NM,
                    z.avg = z.avg, z.avg.p = z.avg.p, z.avg.ci = z.avg.ci, z.avg.sims = zeta.avg,
                    n.avg = n.avg, n.avg.p = n.avg.p, n.avg.ci = n.avg.ci, n.avg.sims = nu.avg,
                    n.avg.NM = n.avg.NM, n.avg.p.NM = n.avg.p.NM, n.avg.ci.NM = n.avg.ci.NM, n.avg.sims.NM = nu.avg.NM,
                    treat = treat, mediator = mediator,
                    conf.level = conf.level,
                    model.y = model.y, model.m = lmodel.m,
                    control.value = control.value, treat.value = treat.value,
                    nobs = N, sims = J,cov=cov,cor=cor,
                    ORd0 = ORd0, ORd1 = ORd1, ORd0.ci = ORd0.ci, ORd1.ci = ORd1.ci, ORd0.p = ORd0.p, ORd1.p = ORd1.p, ORd0.sims = ORdelta.0,ORd1.sims = ORdelta.1,
                    ORd0.NM = ORd0.NM, ORd1.NM = ORd1.NM, ORd0.ci.NM = ORd0.ci.NM, ORd1.ci.NM = ORd1.ci.NM, ORd0.p.NM = ORd0.p.NM, ORd1.p.NM = ORd1.p.NM, ORd0.sims.NM = ORdelta.0.NM, ORd1.sims.NM = ORdelta.1.NM,
                    ORz0 = ORz0, ORz1 = ORz1, ORz0.ci = ORz0.ci,ORz1.ci = ORz1.ci, ORz0.p = ORz0.p, ORz1.p = ORz1.p, ORz0.sims = ORzeta.0, ORz1.sims = ORzeta.1,
                    ORn0 = ORn0, ORn1 = ORn1, ORn0.ci = ORn0.ci, ORn1.ci = ORn1.ci, ORn0.p = ORn0.p, ORn1.p = ORn1.p, ORn0.sims = ORnu.0, ORn1.sims = ORnu.1,
                    ORn0.NM = ORn0.NM, ORn1.NM = ORn1.NM, ORn0.ci.NM = ORn0.ci.NM, ORn1.ci.NM = ORn1.ci.NM, ORn0.p.NM = ORn0.p.NM, ORn1.p.NM = ORn1.p.NM, ORn0.sims.NM = ORnu.0.NM, ORn1.sims.NM = ORnu.1.NM,
                    ORtau.coef = ORtau.coef, ORtau.ci = ORtau.ci, ORtau.p = ORtau.p, ORtau.sims = ORtau,
                    ORd.avg = ORd.avg, ORd.avg.p = ORd.avg.p, ORd.avg.ci = ORd.avg.ci, ORd.avg.sims = ORdelta.avg,
                    ORd.avg.NM = ORd.avg.NM, ORd.avg.p.NM = ORd.avg.p.NM, ORd.avg.ci.NM = ORd.avg.ci.NM, ORd.avg.sims.NM = ORdelta.avg.NM,
                    ORz.avg = ORz.avg, ORz.avg.p = ORz.avg.p, ORz.avg.ci = ORz.avg.ci, ORz.avg.sims = ORzeta.avg,
                    ORn.avg = ORn.avg, ORn.avg.p = ORn.avg.p, ORn.avg.ci = ORn.avg.ci, ORn.avg.sims = ORnu.avg,
                    ORn.avg.NM = ORn.avg.NM, ORn.avg.p.NM = ORn.avg.p.NM, ORn.avg.ci.NM = ORn.avg.ci.NM, ORn.avg.sims.NM = ORnu.avg.NM,
                    logORd0 = logORd0, logORd1 = logORd1, logORd0.ci = logORd0.ci, logORd1.ci = logORd1.ci, logORd0.p = logORd0.p, logORd1.p = logORd1.p, logORd0.sims = logORdelta.0,logORd1.sims = logORdelta.1,
                    logORd0.NM = logORd0.NM, logORd1.NM = logORd1.NM, logORd0.ci.NM = logORd0.ci.NM, logORd1.ci.NM = logORd1.ci.NM, logORd0.p.NM = logORd0.p.NM, logORd1.p.NM = logORd1.p.NM, logORd0.sims.NM = logORdelta.0.NM, logORd1.sims.NM = logORdelta.1.NM,
                    logORz0 = logORz0, logORz1 = logORz1, logORz0.ci = logORz0.ci,logORz1.ci = logORz1.ci, logORz0.p = logORz0.p, logORz1.p = logORz1.p, logORz0.sims = logORzeta.0, logORz1.sims = logORzeta.1,
                    logORn0 = logORn0, logORn1 = logORn1, logORn0.ci = logORn0.ci, logORn1.ci = logORn1.ci, logORn0.p = logORn0.p, logORn1.p = logORn1.p, logORn0.sims = logORnu.0, logORn1.sims = logORnu.1,
                    logORn0.NM = logORn0.NM, logORn1.NM = logORn1.NM, logORn0.ci.NM = logORn0.ci.NM, logORn1.ci.NM = logORn1.ci.NM, logORn0.p.NM = logORn0.p.NM, logORn1.p.NM = logORn1.p.NM, logORn0.sims.NM = logORnu.0.NM, logORn1.sims.NM = logORnu.1.NM,
                    logORtau.coef = logORtau.coef, logORtau.ci = logORtau.ci, logORtau.p = logORtau.p, logORtau.sims = logORtau,
                    logORd.avg = logORd.avg, logORd.avg.p = logORd.avg.p, logORd.avg.ci = logORd.avg.ci, logORd.avg.sims = logORdelta.avg,
                    logORd.avg.NM = logORd.avg.NM, logORd.avg.p.NM = logORd.avg.p.NM, logORd.avg.ci.NM = logORd.avg.ci.NM, logORd.avg.sims.NM = logORdelta.avg.NM,
                    logORz.avg = logORz.avg, logORz.avg.p = logORz.avg.p, logORz.avg.ci = logORz.avg.ci, logORz.avg.sims = logORzeta.avg,
                    logORn.avg = logORn.avg, logORn.avg.p = logORn.avg.p, logORn.avg.ci = logORn.avg.ci, logORn.avg.sims = logORnu.avg,
                    logORn.avg.NM = logORn.avg.NM, logORn.avg.p.NM = logORn.avg.p.NM, logORn.avg.ci.NM = logORn.avg.ci.NM, logORn.avg.sims.NM = logORnu.avg.NM)
      }}
  }
  class(out) <- "mm"
  return(out)
}

triout.NM = function(d1,pm1,d0,pm0){
  NM=length(d1)
  out=rep(NA,4*NM)
  u=seq(1,4*NM,4)
  out[u]=d1
  out[u+1]=pm1
  out[u+2]=d0
  out[u+3]=pm0
  return(out)
}

triout.ci.NM = function(d1.ci,p1.ci,d0.ci,p0.ci){
  NM=length(d1.ci[,1])
  res=array(NA,dim=c(4*NM,2))
  u=seq(1,4*NM,4)
  v=u+1
  w=u+2
  m=u+3

  for (i in 1:NM){
    res[u[i],] = d1.ci[i,]
    res[v[i],] = p1.ci[i,]
    res[w[i],] = d0.ci[i,]
    res[m[i],] = p0.ci[i,]
  }

  return(res)
}

triout.ci.avg.NM = function(d.ci,pm.ci){
  NM = length(d.ci[,1])
  res = array(NA,dim=c(2*NM,2))
  u = seq(1,2*NM,2)
  v = u+1

  for (i in 1:NM){
    res[u[i],] = d.ci[i,]
    res[v[i],] = pm.ci[i,]
  }

  return(res)
}

triout.avg.NM = function(d,pm){
  NM=length(d)
  out=rep(NA,2*NM)
  u=seq(1,2*NM,2)
  out[u]=d
  out[u+1]=pm
  return(out)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary.mm.R
\name{summary.mm}
\alias{summary.mm}
\title{summary.mm}
\usage{
\method{summary}{mm}(object, opt = "navg", logit = "all", ...)
}
\arguments{
\item{object}{element of the class \code{mm}.}

\item{opt}{a character string indicating the details of the analysis "navg" for the average causal effects for t=0,1 and "avg"  for the average causal effects.}

\item{logit}{a character string indicating, when the outcome is binary, the scale of the average causal effects. "effects" for average causal effects, " OR" average causal effects on OR scale, "logOR" average causal effects on logOR scale and "all" for all scale.}

\item{...}{additional arguments affecting the summary produced}
}
\value{
table summarizing the causal analysis
}
\description{
\code{summary.mm} is used to display the results of the mediation analyzes done with \code{multimediate}.
}

\name{data5}
\alias{data5}
\docType{data}
\title{
Toy dataset 5
}
\description{A toy dataset for causal mediation analysis with 3 uncausally related mediators
and survival outcome.
}
\usage{data("data5")}
\format{
  A data frame with 3000 observations on the following 8 variables.
  \describe{
    \item{\code{Exposure}}{a numeric vector}
    \item{\code{M1}}{a numeric vector}
    \item{\code{M2}}{a numeric vector}
    \item{\code{M3}}{a numeric vector}
    \item{\code{event}}{event}
    \item{\code{surv_time}}{time before event}
  }
}

\keyword{datasets}

\name{data2}
\alias{data2}
\docType{data}
\title{
Toy dataset 2
}

\description{A toy dataset for causal mediation analysis with 3 uncausally related mediators.
}
\usage{data("data2")}
\format{
  A data frame with 1000 observations on the following 8 variables.
  \describe{
    \item{\code{Treatment}}{a factor with levels \code{0} \code{1}}
    \item{\code{C1}}{a factor with levels \code{0} \code{1}}
    \item{\code{C2}}{a factor with levels \code{0} \code{1}}
    \item{\code{C3}}{a factor with levels \code{0} \code{1}}
    \item{\code{M1}}{a numeric vector}
    \item{\code{M2}}{a numeric vector}
    \item{\code{M3}}{a numeric vector}
    \item{\code{Outcome}}{a factor with levels \code{FALSE} \code{TRUE}}
  }
}

\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multimediate.R
\name{multimediate}
\alias{multimediate}
\title{multimediate}
\usage{
multimediate(
  lmodel.m,
  correlated = FALSE,
  model.y,
  treat,
  treat.value = 1,
  control.value = 0,
  J = 1000,
  conf.level = 0.95,
  fun = mean,
  data = NULL,
  peryr = 1e+05,
  verbose = TRUE
)
}
\arguments{
\item{lmodel.m}{list of fitted models object for mediators. Can be of class \code{lm}, \code{polr}, \code{glm}.}

\item{correlated}{a logical value. if \code{FALSE} a identity matrix is used for the matrix of correlation of mediators; if \code{TRUE} matrix of correlation is estimated. Default is 'FALSE'.}

\item{model.y}{a fitted model object for the outcome. Can be of class \code{lm}, \code{polr}, \code{glm} or \code{aalen}.}

\item{treat}{a character string indicating the name of the treatment variable used in the models. The treatment can be either binary (integer or a two-valued factor) or continuous (numeric).}

\item{treat.value}{value of the treatment variable used as the treatment condition. Default is 1.}

\item{control.value}{value of the treatment variable used as the control condition. Default is 0.}

\item{J}{number of Monte Carlo draws for quasi-Bayesian approximation.}

\item{conf.level}{level of the returned two-sided confidence intervals. Default is to return the 2.5 and 97.5 percentiles of the simulated quantities.}

\item{fun}{the function used to compute the point estimate of the effects of interest from its empirical distribution. The function \code{mean} or \code{median} can be used. Default is the function \code{mean}.}

\item{data}{dataset with all variables used in the mediator and outcome models}

\item{peryr}{the number of person-years to multiply the additive estimator to obtain results in scale of cases per person-years (only applicable to the survival outcome)}

\item{verbose}{Logical. If \code{TRUE} (default), messages and a progress bar are displayed during execution.}
}
\value{
multimediate returns an object of class \code{mm}, a list that contains at least the components listed below.
The function \code{summary} (i.e., \code{summary.mm}) can be used to obtain a table of the results.
\itemize{
  \item \code{model.y}: the fitted outcome model.
  \item \code{model.m}: a list of fitted mediator models, one for each mediator.
  \item \code{treatment}: a character string indicating the name of the treatment variable used in the models.
  \item \code{treat.value}: value of the treatment variable used as the treatment condition.
  \item \code{control.value}: value of the treatment variable used as the control condition.
  \item \code{sims}: the number of Monte Carlo draws for quasi-Bayesian approximation.
}
}
\description{
\code{multimediate} estimates several quantities in causal mediation analysis, including the average causal mediation effect (indirect effect), average direct effect, proportion mediated, and total effect, in the presence of multiple uncausally related mediators.
}
\details{
For binary outcomes, it also estimates average causal mediation effects on the odds ratio (OR) and log-odds (logOR) scales.

For survival outcomes, \code{multimediate} additionally estimates average causal mediation effects on cases per person-year scale.
}
\examples{
# Load example data
data(data1)
summary(data1)

# Fit mediator models
M1reg <- lm(M1 ~ Treatment + C1 + C2, data = data1)
M2reg <- lm(M2 ~ Treatment + C1 + C3, data = data1)
M3reg <- lm(M3 ~ Treatment + C1, data = data1)

# Fit outcome model
Yreg <- lm(Outcome ~ Treatment + M1 + M2 + M3 + C1 + C2 + C3, data = data1)

# Perform multiple mediation analysis (may take some time)

med.analysis <- multimediate(
  lmodel.m = list(M1reg, M2reg, M3reg),
  correlated = TRUE,
  model.y = Yreg,
  treat = "Treatment",
  treat.value = 1,
  control.value = 0,
  J = 100,
  conf.level = 0.95,
  verbose = FALSE
)

summary(med.analysis, opt = "avg")


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.mm.R
\name{plot.mm}
\alias{plot.mm}
\title{plot.mm}
\usage{
\method{plot}{mm}(
  x,
  treatment = NULL,
  logit = "logOR",
  labels = NULL,
  effect.type = c("indirect", "direct", "total"),
  xlim = NULL,
  ylim = NULL,
  xlab = "",
  ylab = "",
  main = "Estimates and confidence intervals",
  is.legend = TRUE,
  lwd = 1.5,
  cex = 0.85,
  col = "black",
  ...
)
}
\arguments{
\item{x}{element of the class "mm".}

\item{treatment}{a character string indicating the baseline treatment value of the estimated causal mediation effect and direct effect to plot. Can be either "control", "treated", "average" or "three". If "NULL"(default), three sets of estimates are plotted.}

\item{logit}{a character string indicating, when the outcome is binary, the scale of the average causal effects. "effects" for average causal effects, " OR" average causal effects on OR scale, "logOR" average causal effects on logOR scale.}

\item{labels}{a vector of character strings indicating the labels for estimated effects. The default labels wiil be used if NULL.}

\item{effect.type}{a vector indicating which quantities of interest to plot. Default is to plot all three quantities (indirects, direct and total effects).}

\item{xlim}{range of the horizontal axis.}

\item{ylim}{range of the vertical axis.}

\item{xlab}{label of the horizontal axis.}

\item{ylab}{label of the vertical axis.}

\item{main}{main title.}

\item{is.legend}{a logical value indicating the presence of the legend on top right. If the legend obscures some results, is.legend can be switched to "FALSE" or the x-axis can be changed manually with the parameters xlim.}

\item{lwd}{width of the horizontal bars for confidence intervals.}

\item{cex}{size of the dots for point estimates.}

\item{col}{color of the dots and horizontal bars for the estimates.}

\item{...}{additional parameters passed to 'plot'.}
}
\value{
plot summarizing the causal analysis
}
\description{
\code{plot.mm} is used to display the results of the mediation analyzes done with \code{multimediate}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multimediate_survival.R
\name{multimediate_survival}
\alias{multimediate_survival}
\title{multimediate_survival - internal function}
\usage{
multimediate_survival(
  lmodel.m,
  correlated = FALSE,
  model.y,
  treat,
  treat.value = 1,
  control.value = 0,
  J = 1000,
  conf.level = 0.95,
  fun = mean,
  data = NULL,
  peryr = 1e+05,
  verbose = TRUE
)
}
\arguments{
\item{lmodel.m}{A list of fitted mediator models (`lm`, `glm`, or `polr` objects).}

\item{correlated}{a logical value. if 'FALSE' a identity matrix is used for the matrix of correlation of mediators; if 'TRUE' matrix of correlation is estimated. Default is 'FALSE'.}

\item{model.y}{A fitted outcome model (`lm`, `glm`, `polr`, or `aalen` object).}

\item{treat}{The name of the treatment variable (character).}

\item{treat.value}{The value representing the treatment condition (default: 1).}

\item{control.value}{The value representing the control condition (default: 0).}

\item{J}{Number of Monte Carlo simulations for effect estimation (default: 1000).}

\item{conf.level}{Confidence level for confidence intervals (default: 0.95).}

\item{fun}{A summary function applied to the simulated effects (default: `mean`).}

\item{data}{A data frame containing the variables used in the models.}

\item{peryr}{Scaling factor for incidence rates per person-year (default: 100,000).}

\item{verbose}{Logical. If `TRUE` (default), messages and a progress bar are displayed during execution.}
}
\value{
A list containing estimated direct, indirect (mediated), and total effects,
along with confidence intervals and p-values for each.
}
\description{
multimediate_survival - internal function
}
\keyword{internal}
